import {percentageNeededToPassedAutomaticAssessment} from "../src/constants";

export const en_en_Lang = {

  //common

  "yes": 'Yes',
  "no": 'No',
  "ok": "Ok",

  "internalError": "Internal error (see console)",
  "error": "Error",
  "warning": "Warning",
  "add": "Add",
  "result": "Result",
  "other": "Other",
  "change": "Change",
  "delete_": "Delete",
  "cancel": "Cancel",
  "cancel_lower": "cancel",
  "copy": "Copy",


  "resume": "Resume",
  "onFocusInterceptionLayerLabel": "To resume click the button. This will set teh clipboard content to ' '.",

  "change_lower": "change",

  "save": "Save",
  "save_lower": "save",

  "open": "Open",
  "isOpen": "Is open",
  "hints": "Hints",

  "text": "Text",
  "icon": "Icon",
  "serverError": "Server error",

  "language": "Language",
  "misc": "Miscellaneous",
  "discard": "Discard",

  "createdAt": "Created at",
  "lastUpdatedAt": "Last updated at",
  "lastLoginAt": "Last login at",

  "information_pl": "Information",

  "search": "Search",

  //error messages
  "fieldShouldNotBeEmptyOrSpaces": "Field must not be empty or just whitespaces",
  "invalidEditorTheme": "Invalid editor theme",
  "invalidSelectOption": "Invalid option, take other",
  "invalidEmail": "Field value is not a valid email",
  "invalidWorkingTime": "Available working time must be set and >= 1",

  //dialogs
  "deleteCustomTest_title": "Delete custom test",
  "deleteCustomTest_content": "Are you sure you want to delete the custom test?",

  "resetCode_title": "Reset code",
  "resetCode_content": "Are you sure you want to reset your code to the template?",

  "resetCodeToSolution_User_content": "Are you sure you want to reset your code to your submitted solution?",

  "deleteGroupRole_title": "Delete group role",
  "deleteGroupRole_content": "Are you sure you want to delete the group role?",

  "leaveGroup_title": "Leave group",
  "leaveGroup_content": "Are you sure you want to leave the group?",

  "deleteGroup_title": "Delete group",
  "deleteGroup_content": "Are you sure you want to delete the group?",

  "deleteNewUser_title": "Delete new user",
  "deleteNewUser_content": "Are you sure you want to delete the new user?",

  "deleteActivatedUser_title": "Delete activated user",
  "deleteActivatedUser_content": "Are you sure you want to delete the activated user?",

  "deleteTag_title": "Delete tag",
  "deleteTag_content": "Are you sure you want to delete the tag?",

  "releaseMemberFromGroup_title": "Release user from group",
  "releaseMemberFromGroup_content": "Are you sure you want to release the user from this group?",

  "releaseMultipleMembersFromGroup_title": "Release multiple users from group",
  "releaseMultipleMembersFromGroup_content": "Are you sure you want to release multiple users from this group?",

  "deleteSystemRole_title": "Delete system role",
  "deleteSystemRole_content": "Are you sure you want to delete the system role?",

  "resetTutorEditorCode_title": "Reset code to submission",
  "resetTutorEditorCode_content": "Are your sure you want to reset the code to the submissions code?",

  "deleteExercise_title": "Delete exercise",
  "deleteExercise_content": "Are you sure you want to delete the exercise?",

  "rerunAutomaticAssessment_title": "Re-run automatic assessments",
  "rerunAutomaticAssessment_content": "Are you sure you want to re-run all automatic assessments?",

  "deleteRelease_title": "Delete release",
  "deleteRelease_content": "Are you sure you want to delete the release?",

  "resetPassword_title": "Reset password",
  "resetPassword_content": "Are you sure you want to reset the password?",

  "addUsersToGroup_title": "Add users to group",
  "addUsersToGroup_content": "Are you sure you want to add the selected user(s) to the group?",

  "doEditorRecovery_title": "Recover files",
  "doEditorRecovery_content": "If you press 'Yes' then the new files from your browser are taken. If you press 'No' then the files from server are taken. " +
  "If you regret your decision you can reload the page and the question will be asked again.",

  //abbreviations
  "minutes_abbr": "m",
  "seconds_abbr": "s",

  //editor settings
  "change_editor_settings": "Change Editor settings",
  "theme": "Theme",
  "light": "Light",
  "dark": "Dark",

  "cookie_info": "We use cookies to store information across sessions.\n" +
  "By signing in you agree to",
  "cookie_info_link": "our use of cookies.",

  "defaultLightTheme": 'Default light',
  "defaultDarkTheme": 'Default dark',

  "fontSize": "Font size",
  "tabSize": "Tab size",
  "showLineNumbers": "Show line numberrs",
  "useWrapping": "Use wrapping",
  "useWrapping_desc": "visual line break",
  "showLineIndentations": "Show line indentations",

  "loading": "Loading ...",

  //login form
  "wrongUsernameOrPassword": "Wrong username or password",
  "login": "Login",
  "username": "Username",
  "password": "Password",
  "forgotPassword": "Forgot Password?",
  "forgotPassword_text": "Talk to the tutor, he/she will reset your password.",
  "signIn": "Sign In",
  "register": "Register",

  //rergister form
  "passwordAndAgainPasswordDontMatch": "The password and the again password don't match.",
  "registerSuccessful": "Registered",
  "registerSuccessful_text": "Register was successful but the Admin needs to activate your account.",
  "token": "Token",
  "passwordAgain": "Password again",
  "firstName": "First name",
  "lastName": "Last name",
  "email": "Email",

  //editor
  "thisIsTheMainFile": "This is the main file",
  "thisFileWasChangedSinceLastSave": "This file was changed since last save",
  "atLeastOneFileHasChanged": "At least one file has changed",
  "readonlyFile_desc": "This file is readonly",
  "noFileSelected": "No file selected",
  "noFileAvailable": "No files",


  //site header bar
  "exercisesGroup": "Exercises",
  "manageExercisesGroup": "Manage exercises",
  "manageUsersGroup": "Manage users",
  "manageGroupsAndRolesGroup": "Manage groups & roles",

  "allOpenExercises": "All open exercises",
  "allClosedExercises": "All closed exercises",
  "ownExercises": "Own exercises",
  "groupExercises": "Group exercises",
  "groups": "Groups",
  "groupRoles": "Group roles",
  "manageNewUsers": "Manage new users",
  "manageActivatedUsers": "Manage activated users",
  "systemRoles": "System roles",

  "systemRole": "System role",
  "ownSettingsSite": "Settings",
  "logoutError": "Logout error",
  "log": "Log",
  "logout": "Logout",

  "home": "Home",
  "dashboard": "Dashboard",
  "openExercisesViaCode": "Open exercises via code",
  "openExercisesViaVisibility": "Open exercises via visibility",

  "closedExercisesViaCode": "Closed exercises via code",
  "closedExercisesViaVisibility": "Closed exercises via visibility",
  "newExercises": "New exercise",
  "manageTags": "Manage Tags",
  "about": "About",

  //about site
  "projectTitle": "YAPEX",
  "projectDescription": "YAPEX is a system for programming language independent, automatic testing and assessment of exercises.",
  "design": "Design",
  "frameworks": "Frameworks",
  "projectPeople": "Project people",

  //allAccessibleExercisesSite

  "leftWorkingTime": "Left working time",
  "releaseEndAt_label": "End",
  "manual": "Manual",

  "displayName": "Name",
  "description": "Description",
  "releaseCode": "Release code",
  "availableWorkingTimeInMin": "Working time in min",
  "availableWorkingTimeInMin_helpText": "When re-releasing a release the working time won't reset!",
  "hasLimitedWorkingTimeCheckbox_text": "limit",
  "tags": "Tags",
  "enterReleaseCode": "Enter release code",

  "shortDescription": "Description",
  "remainingTime": "Time left",

  //do editor

  //console
  "arguments_": "Arguments",
  "invalidTestResultLine": "unknown/ignored line",
  "useDiffIfOutputMismatchedTrue_desc": "The previous (your) output was wrong. This is the correct output. " +
  "Blue characters are missing, red ones are too much (inside your output) [For regex lines, starting with '(regex):' there is no diff display option]. ",

  "useDiffIfOutputMismatchedFalse_desc": "The previous (your) output was wrong. This is the correct output.",
  "useDiffIfOutputMismatched": "Use diff",
  "useDiffIfOutputMismatched_helpText": "If enabled and your output was wrong then the diff against the expected output is displayed as your output. If disabled the wrong output is marked red instead. For further help (if enabled) hover over the rectangle left to the expected output.",

  "useReplaceWhitespacesWithBullets": "Replace Spaces",
  "useReplaceWhitespacesWithBullets_helpText": "Replaces all whitespaces with · and all tabs with ⇥ in the input and output",


  "EOT": "End of expected output",

  "state": "State",
  "compileError": "Compiler error",
  "outputMismatched": "Wrong output",
  "unknownTestType": "Unknown test type",
  "timeout": "Timeout",
  "diskSpaceLimit": "Disk space limit",
  "ramLimit": "RAM limit",
  "unknownTestServerError": "Unknown test-server error",
  "userProgramError": "User program error",

  "test": "Test",

  "input": "Input",
  "output": "Output",
  "program": "Program",

  //custom tests
  "createCustomTest": "Create custom test",
  "changeCustomTest": "Change custom test",
  "openHelpInNewTab": "Open help in new tab",

  "testContent": "Test content",
  "testContentVisually": "Test content visually",
  "testSettingsAndFiles": "Test settings & files",

  "timeoutInMs": "Timeout in ms",
  "maxRamInKb": "Max. RAM in Kb",
  "maxDiskSpaceInKb": "Max disk space in kb",

  "files": "Files",

  "runAllTests": "Run all tests",
  "runAllTests_desc": "Runs all not passed tests. Have all tests pass then all tests are re-run.",
  "maxParallelTests": "Max parallel tests",

  "editorSettings": "Editor settings",
  "resetCode": "Reset code",
  "resetCode_helpText": "Resets your code to the template but does not saves the new code in the editor to the server.",
  "resetSubsequentEditor_helpText": "Resets the code to your readonly solution",

  //submit tests panel
  "reachedSubmitTestPoints_helpText": `you need at least (>= ${percentageNeededToPassedAutomaticAssessment}) to pass the exercise. The weight (points) of the tests is displayed as the background of each test.`,

  "showTestContent": "Show Content",

  //do editor site
  "editor": "Editor",
  "solutionEditor": "Solution editor",
  "descriptionEditor": "Description editor",
  "subsequentEditor": "Subsequent editor",

  //after for assessment because of performance probably
  "subsequentEditor_helpText" : "The editor that is displayed after the release & the automatic assessment have finished. You can try to solve the exercise (again) with this editor BUT you cannot save!",
  "exerciseTaskDescription": "Task description",
  "normalTests": "Normal tests",
  "normalTestsPoints": "Normal points",
  "submitTestsPoints": "Submit points",
  "customTests": "Custom tests",
  "submitTests": "Submit tests",
  "consoleView": "Console output",

  "couldNotSaveFiles": "Could not save files",
  "savedFiles": "Saved files",

  "youHaveUnsavedChangedYouWantToExit": "You have unsaved changes, do you really want to exit?",

  "saveAllFiles": "Save all files",
  "saveAllFiles_helpText": "Shortcut: ctrl+s",
  "saveCustomProject_helpText": "Shortcut: ctrl+s. At least one file is needed.",

  "compileSingleFile": "Compile single file",
  "compileSingleFile_helpText": "Saves all files (ONLY if the editor has unsaved changes) and compiles the program with the current file as main file.",

  "justRunProgram": "Just Run Program",
  "justRunProgram_helpText": 'Saves all files (ONLY if the editor has unsaved changes) and runs the program without any input (except the given args). If one arg should contain whitespaces enclose it in "" because args are separated by whitespaces. The max length for the program args is ',

  "releaseHasFinished": "Release finished",


  //exercise editor site
  "createTemplate": "Create template",
  "changeTemplate": "Change template",

  "pLang": "Programming language",
  "mainFile": "Main file",
  "mainFile_desc": "The main file that will be executed. E.g. in java this is the file with the class containing the main method.",
  "atLeastOneFileIsNeeded": "At least one file is needed",

  "fileName": "File name",
  "changeableByUser": "Changeable by user",

  "allPLangsAlreadyHaveATemplate": "All programming languages have already a code template.",

  "usersAreAllowedToCreateCustomTests": "Users are allowed to create custom tests",
  "usersAreAllowedToCreateCustomFiles": "Users are allowed to create new files",
  "exerciseIsOnlyVisibleToOwner": "Exercise is only visible to owner (in group exercises view)",
  "showSubmitTestResults": "Show submit test results TOOD???",
  "defaultTestSettingsForCustomTests": "Default settings for custom tests",
  "managedByGroup": "Managed by group",


  //exerciseTestsPanel
  "createNormalTest": "Create normal test",
  "changeNormalTest": "Change normal test",

  "createSubmitTest": "Create submit test",
  "changeSubmitTest": "Change submit test",

  "testType": "Type",
  "points": "Points",

  "chooseTags": "Choose tags",
  "removeAll": "Remove all",
  "properties": "Properties",
  "preview": "Preview",
  "guide": "Guide",
  "templates": "Templates",
  "assets": "Assets",
  "note": "Note",

  "couldNotSaveExercise": "Could not save exercise",
  "couldNotUpdateExercise": "Could not update exercise",

  "couldNotCreateCustomProject": "Could not create custom project",
  "couldNotUpdateCustomProject": "Could not update custom project",

  "updatedExercise": "Updated exercise",
  "exitExerciseEditorSiteMessage": "If you have unsaved changes then they will be discarded. Do you want to leaf the page anyway?",

  "createExercise": "Create exercise",
  "changeExercise": "Change exercise",

  "changeCustomProject": "Save project",

  "exportExercise": "Export exercise",
  "importExercise": "Import exercise",

  "createGroupRole": "Create group role",
  "changeGroupRole": "Change group role",
  "deleteGroupRole": "Delete group role",

  //group role permissions
  "canCreateExercises": "Can create exercises",
  "canChangeExercises": "Can change exercises",
  "canDeleteExercises": "Can delete exercises",
  "canReleaseExercises": "Can release exercises",
  "canCopyExercises": "Can copy exercises",
  "canSeeExercisesFromOthersInGroup": "Can see exercises from other members",

  "canAddUserToGroup": "Can add users to group",
  "canRemoveMemberFromGroup": "Can remove members from group",
  "canChangeOtherMembersRole": "Can change other members group role",

  "submissions": "Submissions",
  "canAssessExercises": "Can assess exercises from group (manually or/and automatic TODO???)",


  "createGroup": "Create group",
  "changeGroup": "Change group",
  "members": "Members",
  "leaveGroup": "Leave",

  //home site
  "allOpenExercises_desc": "On this site all open exercises are displayed (that can be solved).",
  "ownExercises_desc": "On this site all your exercises are displayed (where you are the owner).",
  "groupExercises_desc": "On this site all exercises of groups are displayed where you are a member.",

  //manageNewUsersSite
  "activateSelectedUsers": "Activate selected users",
  "deleteSelectedUsers": "Delete selected users",

  "noSystemRole": "None",
  "activateNewUser": "Activate",

  //manageTagsSite
  "createTag": "Create tag",
  "changeTag": "Change tag",

  "fontColor": "Font color",
  "backgroundColor": "Background color",
  "cssColors_helpText": "All css colors are allowed, so also red, green, ... You can click on the brush to open a color picker.",

  //ownSettingsSite
  "oldPassword": "Old Password",
  "newPassword": "New password",
  "newPasswordAgain": "New password again",

  "thisDataCanOnlyBeChangedByAdmin": "This data can only be changed by an admin.",

  ////singleGroupSite
  "addUsersToGroup": "Add user to group",
  "invertSelection": "Invert selection",
  "isActive": "Active",
  "isActivated_HelpText": "Indicates if the user is already active or if this is a new user (not activated yet).",
  "addSelectedUsers": "Add selected users",

  "groupRole": "Group role",
  "isActivated": "Is Active",
  "isNotActivated": "Not active",
  "releaseMemberFromGroup": "Release member",
  "thisIsYou": "This is you!",
  "addMember": "Add member",
  "releaseSelectedMemberFromGroup": "Release selected member",


  //systemRolesSite
  "createSystemRole": "Create system role",
  "changeSystemRole": "Change system role",
  "deleteSystemRole": "Delete system role",

  "canCreateGroups": "Can create groups",
  "canChangeGroups": "Can change groups",
  "canDeleteGroups": "Can delete groups",
  "canCreateRoles": "Can create system & group roles",
  "canChangeRoles": "Can change system & group  roles",
  "canDeleteRoles": "Can delete system & group  roles",
  "canManageNewUsers": "Can manage new users",
  "canChangeOtherUsersSystemRole": "Can change other users system role",
  "canDeleteActivatedUsers": "Can delete & view activated users",
  "canChangeOtherUserData": "Can change other user data & view activated users",
  "canChangeSystemSettings": "Can change system settings",
  "canManageTags": "Can manage tags",
  "canViewDashboard": "Can view dashboard",

  //tutorViewSite
  "saveManualAssessment": "Save manual assessment",
  "manualAssessmentSaved": "Manual assessment saved",
  "thereIsNoAutomaticAssessmentYet": "There is no automatic assessment yet.",
  "normalTestPoints": "Normal test points",
  "noNormalTestPoints_helpText": "If there are no points then the automatic assessment option might be disabled (for the release) or there was an automatic assessment error.",
  "submitTestPoints": "Submit test points",
  "noSubmitTestPoints_helpText": "If there are no points then the automatic assessment option might be disabled (for the release) or there was an automatic assessment error.",
  "manualPoints": "Manual points",
  "manualPoints_helpText": "Points that a tutor has assigned",
  "notAssessedPoints": "Not assessed",

  "noteForOtherTutors": "Note for other tutors",
  "feedbackForStudent": "Feedback for student",
  "feedback": "Feedback",
  "feedbackFormTutor_helpText": "Feedback from tutor",

  "resetTutorEditorCode": "Reset Code to submission",

  "tutorEditor": "Tutor-Editor",
  "tutorEditor_helpText": "This editor is used to check and assess the submission manually. It's also used to run the tests.",
  "submissionCodeEditor": "Submission code",
  "submissionCode_helpText": "This editor displays the original submission in a readonly editor.",
  "manualAssessment": "Manual assessment",

  "theSubmitTestResultsAreOnlyDisplayedAfterAutomaticAssessmentHasFinished": "The submit tests results are only displayed after the automatic assessment has finished.",

  "theReleaseIsStillOpen": "The release is still open.",
  "theReleaseIsStillOpenOrAssessmentNotYetFinished": "The release is still open or the automatic assessment has not finished yet",

  "tutorNormalTests": "Tutor-Tests",
  "tutorSubmitTests": "Tutor-Submit-Tests",

  //manageOwnOrGroupExerciseComponents
  "isOnlyVisibleToOwner": "Only visible to me",
  "solutions": "Solutions",
  "releases": "Releases",
  "copyExercise": "Copy",
  "copyExercise_helpText": "This opens the exercise in the create exercise site view.",
  "deleteExerciseOnlyIfNoReleasesLeft": "The exercise can only be deleted if it has no releases.",

  //submissionsSite
  "refreshViw": "Refresh view",
  "exportAssessments": "Export assessments",
  "downloadAllSubmissions": "Download all submissions",
  "rerunAutomaticAssessment": "Re-run automatic assessments",
  "rerunAutomaticAssessment_helpText": "This re-runs all submit tests (and normal tests if specified in the release) and preserves the manual points and comments (for student, other tutors). This is also the case for single re-run.",
  "normalTestsAssessment_helpText": "The summed normal test points. The percentage represent the students where all normal tests passed and the participation should count. If nothing is displayed none normal test was run yet.",
  "submissionTestsAssessment_helpText": "The summed submit test points. The percentage represent the students where all submit tests passed and the participation should count. If nothing is displayed none submit test was run yet.",
  "download": "Download",
  "rerunSingleAutomaticAssessment": "Re-run",
  "openTutorView": "Open as tutor",
  "openTutorView_helpText": "In the tutor view you can view the submission, the test results and manually assess the submission.",
  "submissionsOf": "Submissions of",
  "shouldNotCount": "Should not count",
  "participationCount_helpText": "The times the user solved this exercise. " +
  "If a user solved the exercise (release) in different programming languages then two rows are shown but it's the same participation. " +
  "The participation is counted as one because the restrictions (e.g. lef time, should not count) are stored in the participation.",

  //---assessment states
  "sillReleased": "The release is still released (active).",
  "automaticAssessmentOptionNotSelected": "The automatic assessment option is not selected, please start the automatic assessment manually.",
  "automaticAssessmentHasNotRanYet": "The automatic assessment is activated but has not ran yet.",
  "notReleasedYet": "The release was not released yet.",
  "automaticAssessmentIsCurrentlyRunning": "The automatic assessment ist still running... Refresh the view to see progress.",
  "automaticAssessmentHasFinished": "The automatic assessment has finished",
  "manualStartedAssessmentHasFinished": "The manually started automatic assessment has finished.",
  "automaticAssessmentHasFinishedWithErrors": "The automatic assessment has finished with errors!",

  "automaticRefreshView": "Automatic refresh view",
  "automaticRefreshViewIn": "Automatic refresh view in",

  "releaseStillActiveButUserNormalTestResultsAreDisplayed": "Nevertheless the normal test results of the users latest solution are displayed.",
  "releaseStillActiveButUserNormalTestResultsAreDisplayed_helpText": "If a normal test was not yet run by the user is is treated as not passed.",

  //releasesSite
  "releasesFor": "Releases for",
  "createRelease": "Create release",
  "changeRelease": "Change release",
  "releaseIsActive": "Active",
  "releaseIsVisibleForAll": "Is visible for all",
  "releaseIsVisibleForAll_helpText": "If the release is visible for all then every user can see the release without entering the code.",
  "automatic": "Automatic",
  "unlimitedWorkingTime": "Unlimited",
  "startAt": "Start at",
  "startAt_helpText": "If the start type is automatic then the automatic start time is changed to the actual start time.",
  "endAt": "End at",

  //changeExerciseReleaseDialog
  "startAndEndOfTheRelease": "Start/End of the release",
  "automaticStartAt": "Automatic start at",
  "automaticEndAt": "Automatic end at",
  "durationOfTheAutomaticRelease": "Duration of the automatic release",
  "durationOfTheAutomaticReleaseInfinitely_helpText": "To end the release anyway select the manual mode and end the release manually.",
  "infinitely": "Infinitely",
  "limited": "Limited",

  "options": "Options",
  "examOptions": "Exam options",
  "shouldRunAutomaticAssessment": "Run automatic assessment",
  "shouldRunAutomaticAssessment_helpText": "After the release ended the automatic tests will be run.",
  "shouldRunNormalTestsAlso": "Run normal tests too",
  "shouldRunNormalTestsAlso_helpText": "Normally only the submit tests are run. With this optin enabled the normal tests are also run. This will overwrite the test results from the users.",

  //custom projects sites
  "manageCustomProjectsSite": "Manage custom projects",
  "createCustomProject": "Create custom project",
  "numCustomProjectsLeft": "project(s) left",
  "couldNotLoadCustomProjectOverviews": "Could not load custom projects",
  "couldNotDeleteCustomProject": "Could not delete custom project",

  "deleteCustomProject_title": "Delete custom project",
  "deleteCustomProject_content": "Are you sure you want to delete your project?",

  "isReleased": "Is released",
  "isReleased_helpText": "If you want to start the release then tick the checkbox and save. To end a release uncheck the checkbox and save.",
  "automaticAssessmentIsRunning": "Automatic assessment is still running... please reload the page to get new values",

  "releaseState_automaticTestsWillRun": "If you end the release now then the automatic tests will run",
  "releaseState_automaticTestsWontRun": "If you end the release now then the automatic tests will NOT run (because you didn't tick the option. If you want to run the tests tick the option first and then end the release.",

  "allPLangs": "All",

  "hasLimitedWorkingTime": "Has limited working time",

  "changeUserData": "Change user data",
  "resetPassword": "Reset password",
  "generatedPassword": "Generated password",
  "generatedPassword_helpText": "Resets the password for the selected user to a randomly generated password. The generated password is the displayed here.",


  "noThemeSelected": "Not selected",
  "changeTagIcon_helpText": "Click to open a new tab with all possible icons. Then past the icon text here.",
  "changeTagDescription_helpText": "The description is only displayed on hover.",

  "allWhitespacesOfTheInputAreReplaced": "All whitespaces of the input are replaced with · and all tabs with ⇥",
  "allWhitespacesOfTheOutputAreReplaced": "All whitespaces of the output are replaced with · and all tabs with ⇥",

  "couldNotGetHtmlElementWithSpecificId": "Could not get html element with specific id",
  "couldNotGetPLangForSolution": "The solution programming language is not known",

  "editorFileNotFound": "Could not find editor file",
  "couldNotFindCodeTemplate": "Could not find code template",
  "someUrlParametersNotFound": "Some url parameters were not found/set",
  "probablyNoTestRun": "Probably no test has run",
  "plangIdNotFound": "Could not find programming language for given id",
  "couldNotFindSolutionFile": "Could not find solution file",
  "couldNotConvertStringToInt": "Could not convert string to int",
  "couldNotFindRelease": "Could not find release",
  "somethingWentWrongCalculatingLeftWorkingTime": "Something went wrong calculating left working time",
  "autoSaveFilesOnTestRunIfNecessary": "If the editor has unsaved changes and you run a test then the files will be auto saved before running the test. Tests are saved/updated immediately, no need to save solution/exercise.",
  "submitTestResultStudentHelp": "These are the submit test results. These are executed and visible after the release ended and the automatic assessment has ran.",
  "feedbackFromTutorStudentHelp": "This is the result of the manual assessment. It is only visible if the tutor has left a feedback or manual points for you.",

  "whenAreManualPointsOrFeedbackIsDisplayed_tutor_helpText": "If you assign manual points or feedback for the student then the manual points-and-feedback-panel is displayed to the student.",

  "assessmentStatisticsForUser": "Assessment statistic",
  "myAssessmentStatisticsForUser": "My assessment statistic",
  "myAssessmentStatisticsForUser_description_home": "An overview what exercise you have started and how much points you got.",

  "manageCustomProjects": "My Projects",

  "exercise": "Exercise",
  "exerciseDescription": "Description",
  "lastUpdatedAtSolutionVersion_helpText": "The date & time when the solution got last updated for the exercise (the release).",

  "clearCustomTestResults": "Clear custom test results",
  "clearNormalTestResults": "Clear normal test results",
  "clearSubmitTestResults": "Clear submit test Results",

  "noAutomaticTestResultReset": "Changing the editor content does not auto resets the test results",

  "automaticRelease_helpText": "The automatic start/end can take up to 1 min (1 tick) until it's executed. If the automatic start is before now then the start is executed within the next tick.",

  "tagsFilter": "Tags filter",
  "tagFilter_helpText": "The selected tags are connected via logical and so if you select two tags then both tags needs to be assigned to the exercise. " +
  "If you click a tag twice then the exercise must not have the tag assigned.",

  "doEditorRemainingTime_helpText": "Displays the remaining time. Click to show/hide. If the remaining time is <= ",
  "doEditorRemainingTime_helpText_part2": " the icon color will change.",

  "consoleArguments_helpText": "The console arguments for the program. Separated by whitespaces.",
  "compileSingleFileSuccessful": "Compiled",

  "couldNotRestoreEditorSessionsBecauseMultipleMatchingFilesFound": "Could not restore the editor sessions because found multiple matching editor sessions for one file. Please save all Files and reload the site.",
  "couldNotRestoreEditorSessionsBecauseMultipleNoFileFound": "Could not restore the editor sessions because found no editor sessions for one file. Please save all Files and reload the site.",

  "couldNotFindExercise": "Could not find the exercise",
  "couldNotFindExerciseOrNoPermission": "Could not find the exercise or no permission",
  "couldNotCreateNewFileBecauseFileWithSameNameAlreadyExists": "Could not create new file because there is already a file with the same name.",

  "solutionServerVersionCreatedAt": "Server version:",
  "solutionServerVersionCreatedAt_helpText": "The time when the latest solution was saved/created on the server.",

  "timeUsedUp": "Time used up",
  "parseError": "Parse Error",
  "regexError": "Regex Error",

  "escapeEditor": "Escape editor",
  "escapeEditorResult": "Escaped result",


  "doExerciseShouldNotCount": "Should not count",
  "doExerciseShouldNotCount_helpText": "Your participation will not be counted, this cannot be undone! This does not affect the left working time.",
  "shouldNotCount_helpText_tutor_helpText": "The assessment result/participation should not be counted.",

  "doExerciseShouldNotCount_title": "Participation should not count",
  "doExerciseShouldNotCount_content": "Are you sure you want that your participation should not be counted? This cannot be undone!",

  "couldNotSetShouldNotCount_doExercise": "Could not set 'participation should not count'.",

  "editorExercise_loadingTestAssetContents": "Now loading test assets (before exporting)...",
  "editorExercise_couldNotLoadTestAssetContents": "Could not load test assets",

  "couldNotCreateCustomProjectBecauseExceededMaxAmount": "Could not create custom project because you exceeded the max amount of possible custom projects.",

  "couldNotLoadCustomProject": "Could not load custom project",

  "createdCustomTest": "Created custom test",
  "updatedCustomTest": "Updated custom test",
  "deletedCustomTest": "Deleted custom test",
  "couldNotCreateCustomTest": "Could not create custom test",
  "couldNotUpdateCustomTest": "Could not update custom test",
  "couldNotDeleteCustomTest": "Could not delete custom test",

  "serverSettings": "Server settings",
  "testServerSettings": "Test server settings",
  "logicalUsageStatistic": "Logical usage statistic",
  "property": "Property",
  "value": "Value",

  "hardwareCharts": "Hardware charts",
  "cpuUsageChartCaption": "CPU",
  "ramUsageChartCaption": "RAM",
  "free": "free",
  "liveRefresh_helpText": "This view/panel is live and will automatically refresh (not the whole site).",
  "downloadEditExerciseAssets_helpText": "If you create an asset/file you cannot directly download it again because it was not created on the server yet. Save the exercise (which will upload the asset/file) and reload the site.",

  "hideReleaseInOverviews": "Hide release in overviews",
  "hideReleaseInOverviews_column": "Hide in overviews",
  "hideReleaseInOverviews_helpText": "Hides the release from the student in all exercise overviews and statistic views",

  "shouldClearClipboardOnFocus": "Clear clipboard on focus (EXPERIMENTAL, known issues)",
  "shouldClearClipboardOnFocus_column": "Clear clipboard",
  "shouldClearClipboardOnFocus_helpText": "Shows an overlay to resume when the window/tab lost focus. This will clear the clipboard when accepted else the student can't proceed.",

  "doExerciseLinkExamMode_hint" : "You can manually add /exam to the link for students (e.g. https://.../#/doeditor/exercises/5cn2o8ajk2n3-7bdd/exam) to hide the site menu bar (when distributing the link).",

  "hideSiteHeaderBar" : "Hide site header bar",
  "hideSiteHeaderBar_helpText": "Hides the header bar (checked) or displays it (unchecked). The site header bar is the topmost bar where the site menu, user menu is located. This setting is overwritten by url parameters (e.g. /exam which will hide the site header bar, thus overwriting this setting)."

}