/**
 * Created by janis dähne.
 */


export enum TranslateIds {
  //common


  yes = 'yes',
  no = 'no',
  ok = "ok",
  internalError = "internalError",
  error = "error",
  warning = "warning",
  add = "add",
  result = "result",
  other = "other",
  delete_ = "delete_",
  cancel = "cancel",
  cancel_lower = "cancel_lower",

  change = "change",
  change_lower = "change_lower",

  save = "save",
  save_lower = "save_lower",
  text = "text",
  icon = "icon",
  copy = "copy",

  resume = "resume",
  onFocusInterceptionLayerLabel = "onFocusInterceptionLayerLabel",

  serverError = "serverError",

  createdAt = "createdAt",
  lastUpdatedAt = "lastUpdatedAt",
  lastLoginAt = "lastLoginAt",

  open = "open",
  isOpen = "isOpen",
  search = "search",

  language = "language",
  misc = "misc",
  discard = "discard",
  information_pl = "information_pl",

  //error messages
  fieldShouldNotBeEmptyOrSpaces = "fieldShouldNotBeEmptyOrSpaces",
  invalidEditorTheme = "invalidEditorTheme",
  invalidSelectOption = "invalidSelectOption",
  invalidEmail = "invalidEmail",
  invalidWorkingTime = "invalidWorkingTime",

//dialogs
  deleteCustomTest_title = "deleteCustomTest_title",
  deleteCustomTest_content = "deleteCustomTest_content",

  resetCode_title = "resetCode_title",
  resetCode_content = "resetCode_content",

  resetCodeToSolution_User_content = 'resetCodeToSolution_User_content',

  deleteGroupRole_title = "deleteGroupRole_title",
  deleteGroupRole_content = "deleteGroupRole_content",

  leaveGroup_title = "leaveGroup_title",
  leaveGroup_content = "leaveGroup_content",

  deleteGroup_title = "deleteGroup_title",
  deleteGroup_content = "deleteGroup_content",

  deleteNewUser_title = "deleteNewUser_title",
  deleteNewUser_content = "deleteNewUser_content",

  deleteActivatedUser_title = "deleteActivatedUser_title",
  deleteActivatedUser_content = "deleteActivatedUser_content",

  deleteTag_title = "deleteTag_title",
  deleteTag_content = "deleteTag_content",

  releaseMemberFromGroup_title = "releaseMemberFromGroup_title",
  releaseMemberFromGroup_content = "releaseMemberFromGroup_content",

  releaseMultipleMembersFromGroup_title = "releaseMultipleMembersFromGroup_title",
  releaseMultipleMembersFromGroup_content = "releaseMultipleMembersFromGroup_content",

  deleteSystemRole_title = "deleteSystemRole_title",
  deleteSystemRole_content = "deleteSystemRole_content",

  resetTutorEditorCode_title = "resetTutorEditorCode_title",
  resetTutorEditorCode_content = "resetTutorEditorCode_content",

  deleteExercise_title = "deleteExercise_title",
  deleteExercise_content = "deleteExercise_content",

  rerunAutomaticAssessment_title = "rerunAutomaticAssessment_title",
  rerunAutomaticAssessment_content = "rerunAutomaticAssessment_content",

  deleteRelease_title = "deleteRelease_title",
  deleteRelease_content = "deleteRelease_content",

  resetPassword_title = "resetPassword_title",
  resetPassword_content = "resetPassword_content",

  addUsersToGroup_title = "addUsersToGroup_title",
  addUsersToGroup_content = "addUsersToGroup_content",

  doEditorRecovery_title = "doEditorRecovery_title",
  doEditorRecovery_content = "doEditorRecovery_content",


//abbreviations
  "minutes_abbr" = "minutes_abbr",
  seconds_abbr = "seconds_abbr",

  //editor settings
  change_editor_settings = "change_editor_settings",
  theme = "theme",
  light = "light",
  dark = "dark",

  cookie_info = 'cookie_info',
  cookie_info_link = 'cookie_info_link',

  defaultLightTheme = 'defaultLightTheme',
  defaultDarkTheme = 'defaultDarkTheme',

  fontSize = "fontSize",
  tabSize = "tabSize",
  showLineNumbers = "showLineNumbers",
  useWrapping = "useWrapping",
  useWrapping_desc = "useWrapping_desc",
  showLineIndentations = "showLineIndentations",

  loading = "loading",

  //login form
  wrongUsernameOrPassword = "wrongUsernameOrPassword",
  login = "login",
  password = "password",
  forgotPassword = "forgotPassword",
  forgotPassword_text = "forgotPassword_text",
  signIn = "signIn",
  register = "register",

  //rergister form
  passwordAndAgainPasswordDontMatch = "passwordAndAgainPasswordDontMatch",
  registerSuccessful = "registerSuccessful",
  registerSuccessful_text = "registerSuccessful_text",
  token = "token",
  passwordAgain = "passwordAgain",
  firstName = "firstName",
  lastName = "lastName",
  email = "email",

  //editor
  thisIsTheMainFile = "thisIsTheMainFile",
  thisFileWasChangedSinceLastSave = "thisFileWasChangedSinceLastSave",
  atLeastOneFileHasChanged = "atLeastOneFileHasChanged",
  readonlyFile_desc = "readonlyFile_desc",
  noFileSelected = "noFileSelected",
  noFileAvailable = "noFileAvailable",

  //site menu
  exercisesGroup = "exercisesGroup",
  manageExercisesGroup = "manageExercisesGroup",
  manageUsersGroup = "manageUsersGroup",
  manageGroupsAndRolesGroup = "manageGroupsAndRolesGroup",

  allOpenExercises = "allOpenExercises",
  allClosedExercises = "allClosedExercises",
  ownExercises = "ownExercises",
  groupExercises = "groupExercises",
  groups = "groups",
  groupRoles = "groupRoles",
  manageNewUsers = "manageNewUsers",
  manageActivatedUsers = "manageActivatedUsers",
  systemRoles = "systemRoles",

  systemRole = "systemRole",
  ownSettingsSite = "ownSettingsSite",
  logoutError = "logoutError",
  log = "log",
  logout = "logout",

  home = "home",
  dashboard = "dashboard",
  openExercisesViaCode = "openExercisesViaCode",
  openExercisesViaVisibility = "openExercisesViaVisibility",

  closedExercisesViaCode = "closedExercisesViaCode",
  closedExercisesViaVisibility = "closedExercisesViaVisibility",
  newExercises = "newExercises",
  manageTags = "manageTags",
  about = "about",

  //about
  projectTitle = "projectTitle",
  projectDescription = "projectDescription",
  design = "design",
  frameworks = "frameworks",
  projectPeople = "projectPeople",

  //all/te
  leftWorkingTime = "leftWorkingTime",
  releaseEndAt_label = "releaseEndAt_label",
  manual = "manual",

  displayName = "displayName",
  description = "description",
  releaseCode = "releaseCode",
  availableWorkingTimeInMin = "availableWorkingTimeInMin",
  availableWorkingTimeInMin_helpText = "availableWorkingTimeInMin_helpText",
  hasLimitedWorkingTimeCheckbox_text = "hasLimitedWorkingTimeCheckbox_text",
  tags = "tags",
  enterReleaseCode = "enterReleaseCode",
  shortDescription = "shortDescription",
  remainingTime = "remainingTime",

  //do editor
  arguments_ = "arguments_",
  invalidTestResultLine = "invalidTestResultLine",

  useDiffIfOutputMismatchedTrue_desc = 'useDiffIfOutputMismatchedTrue_desc',
  useDiffIfOutputMismatchedFalse_desc = 'useDiffIfOutputMismatchedFalse_desc',
  useDiffIfOutputMismatched = 'useDiffIfOutputMismatched',
  useDiffIfOutputMismatched_helpText = "useDiffIfOutputMismatched_helpText",

  useReplaceWhitespacesWithBullets = "useReplaceWhitespacesWithBullets",
  useReplaceWhitespacesWithBullets_helpText = "useReplaceWhitespacesWithBullets_helpText",

  EOT = "EOT", //enf of test

  state = "state",
  compileError = "compileError",
  outputMismatched = "outputMismatched",
  unknownTestType = "unknownTestType",
  timeout = "timeout",
  diskSpaceLimit = "diskSpaceLimit",
  ramLimit = "ramLimit",
  unknownTestServerError = "unknownTestServerError",
  userProgramError = "userProgramError",

  test = "test",

  input = "input",
  output = "output",
  program = "program",
  createCustomTest = "createCustomTest",
  changeCustomTest = "changeCustomTest",

  openHelpInNewTab = "openHelpInNewTab",

  testContent = "testContent",
  testContentVisually = "testContentVisually",
  testSettingsAndFiles = "testSettingsAndFiles",

  timeoutInMs = "timeoutInMs",
  maxRamInKb = "maxRamInKb",
  maxDiskSpaceInKb = "maxDiskSpaceInKb",
  files = "files",

  runAllTests = "runAllTests",
  runAllTests_desc = "runAllTests_desc",
  maxParallelTests = "maxParallelTests",

//do editor
  editorSettings = "editorSettings",
  resetCode = "resetCode",
  resetCode_helpText = "resetCode_helpText",
  resetSubsequentEditor_helpText = "resetSubsequentEditor_helpText",

//submit test panel
  reachedSubmitTestPoints_helpText = "reachedSubmitTestPoints_helpText",
  showTestContent = "showTestContent",

//do editor site
  editor = "editor",
  solutionEditor = "solutionEditor",
  descriptionEditor = "descriptionEditor",
  subsequentEditor = "subsequentEditor",
  subsequentEditor_helpText = "subsequentEditor_helpText",
  exerciseTaskDescription = "exerciseTaskDescription",
  normalTests = "normalTests",
  normalTestsPoints = "normalTestsPoints",
  customTests = "customTests",
  submitTests = "submitTests",
  submitTestsPoints = "submitTestsPoints",
  consoleView = "consoleView",

  couldNotSaveFiles = "couldNotSaveFiles",
  savedFiles = "savedFiles",
  youHaveUnsavedChangedYouWantToExit = "youHaveUnsavedChangedYouWantToExit",

  saveAllFiles = "saveAllFiles",
  saveAllFiles_helpText = "saveAllFiles_helpText",
  saveCustomProject_helpText = "saveCustomProject_helpText",

  compileSingleFile = "compileSingleFile",
  compileSingleFile_helpText = "compileSingleFile_helpText",

  justRunProgram = "justRunProgram",
  justRunProgram_helpText = "justRunProgram_helpText",

  releaseHasFinished = "releaseHasFinished",

//exercise editor site
  createTemplate = "createTemplate",
  changeTemplate = "changeTemplate",

  pLang = "pLang",
  mainFile = "mainFile",
  mainFile_desc = "mainFile_desc",
  atLeastOneFileIsNeeded = "atLeastOneFileIsNeeded",
  fileName = "fileName",
  changeableByUser = "changeableByUser",
  allPLangsAlreadyHaveATemplate = "allPLangsAlreadyHaveATemplate",

//settings panel
  usersAreAllowedToCreateCustomTests = "usersAreAllowedToCreateCustomTests",
  usersAreAllowedToCreateCustomFiles = "usersAreAllowedToCreateCustomFiles",
  exerciseIsOnlyVisibleToOwner = "exerciseIsOnlyVisibleToOwner",
  showSubmitTestResults = "showSubmitTestResults",

  defaultTestSettingsForCustomTests = "defaultTestSettingsForCustomTests",
  managedByGroup = "managedByGroup",

//exerciseTestsPanel
  createNormalTest = "createNormalTest",
  changeNormalTest = "changeNormalTest",

  createSubmitTest = "createSubmitTest",
  changeSubmitTest = "changeSubmitTest",

  testType = "testType",
  points = "points",


  chooseTags = "chooseTags",
  removeAll = "removeAll",
  properties = "properties",
  preview = "preview",
  guide = "guide",
  templates = "templates",
  assets = "assets",
  note = "note",

  couldNotSaveExercise = "couldNotSaveExercise",
  couldNotUpdateExercise = "couldNotUpdateExercise",

  couldNotCreateCustomProject = "couldNotCreateCustomProject",
  couldNotUpdateCustomProject = "couldNotUpdateCustomProject",

  updatedExercise = "updatedExercise",
  exitExerciseEditorSiteMessage = "exitExerciseEditorSiteMessage",

  createExercise = "createExercise",
  changeExercise = "changeExercise",

  changeCustomProject = "changeCustomProject",

  exportExercise = "exportExercise",
  importExercise = "importExercise",

  createGroupRole = "createGroupRole",
  changeGroupRole = "changeGroupRole",
  deleteGroupRole = "deleteGroupRole",


//group role permissions
  canCreateExercises = "canCreateExercises",
  canChangeExercises = "canChangeExercises",
  canDeleteExercises = "canDeleteExercises",
  canReleaseExercises = "canReleaseExercises",
  canCopyExercises = "canCopyExercises",
  canSeeExercisesFromOthersInGroup = "canSeeExercisesFromOthersInGroup",

  canAddUserToGroup = "canAddUserToGroup",
  canRemoveMemberFromGroup = "canRemoveMemberFromGroup",
  canChangeOtherMembersRole = "canChangeOtherMembersRole",

  submissions = "submissions",
  canAssessExercises = "canAssessExercises",


//groups site
  createGroup = "createGroup",
  changeGroup = "changeGroup",
  members = "members",
  leaveGroup = "leaveGroup",

//home site
  allOpenExercises_desc = "allOpenExercises_desc",
  ownExercises_desc = "ownExercises_desc",
  groupExercises_desc = "groupExercises_desc",

//manageNewUsersSite

  activateSelectedUsers = "activateSelectedUsers",
  deleteSelectedUsers = "deleteSelectedUsers",

  noSystemRole = "noSystemRole",

  activateNewUser = "activateNewUser",


//manageTagsSite
  createTag = "createTag",
  changeTag = "changeTag",

  fontColor = "fontColor",
  backgroundColor = "backgroundColor",
  cssColors_helpText = "cssColors_helpText",

//ownSettingsSite
  oldPassword = "oldPassword",
  newPassword = "newPassword",
  newPasswordAgain = "newPasswordAgain",

  thisDataCanOnlyBeChangedByAdmin = "thisDataCanOnlyBeChangedByAdmin",

//singleGroupSite
  addUsersToGroup = "addUsersToGroup",
  invertSelection = "invertSelection",
  isActive = "isActive",
  addSelectedUsers = "addSelectedUsers",

  groupRole = "groupRole",
  isActivated = "isActivated",
  isActivated_HelpText = "isActivated_HelpText",
  isNotActivated = "isNotActivated",
  releaseMemberFromGroup = "releaseMemberFromGroup",

  thisIsYou = "thisIsYou",
  addMember = "addMember",
  releaseSelectedMemberFromGroup = "releaseSelectedMemberFromGroup",

  //systemRolesSite
  createSystemRole = "createSystemRole",
  changeSystemRole = "changeSystemRole",
  deleteSystemRole = "deleteSystemRole",

  canCreateGroups = "canCreateGroups",
  canChangeGroups = "canChangeGroups",
  canDeleteGroups = "canDeleteGroups",
  canCreateRoles = "canCreateRoles",
  canChangeRoles = "canChangeRoles",
  canDeleteRoles = "canDeleteRoles",
  canManageNewUsers = "canManageNewUsers",
  canChangeOtherUsersSystemRole = "canChangeOtherUsersSystemRole",
  canDeleteActivatedUsers = "canDeleteActivatedUsers", //AND view
  canChangeOtherUserData = "canChangeOtherUserData", //OTHER user data (activated users)
  canChangeSystemSettings = "canChangeSystemSettings",
  canManageTags = "canManageTags",
  canViewDashboard = "canViewDashboard",

  //tutorViewSite
  saveManualAssessment = "saveManualAssessment",
  manualAssessmentSaved = "manualAssessmentSaved",
  thereIsNoAutomaticAssessmentYet = "thereIsNoAutomaticAssessmentYet",
  normalTestPoints = "normalTestPoints",
  noNormalTestPoints_helpText = "noNormalTestPoints_helpText",
  submitTestPoints = "submitTestPoints",
  noSubmitTestPoints_helpText = "noSubmitTestPoints_helpText",
  manualPoints = "manualPoints",
  manualPoints_helpText = "manualPoints_helpText",
  notAssessedPoints = "notAssessedPoints",

  noteForOtherTutors = "noteForOtherTutors",
  feedbackForStudent = "feedbackForStudent",
  feedbackFormTutor_helpText = "feedbackFormTutor_helpText",
  feedback = "feedback",


  resetTutorEditorCode = "resetTutorEditorCode",

  tutorEditor = "tutorEditor",
  tutorEditor_helpText = "tutorEditor_helpText",
  submissionCodeEditor = "submissionCodeEditor",
  submissionCode_helpText = "submissionCode_helpText",
  manualAssessment = "manualAssessment",

  theSubmitTestResultsAreOnlyDisplayedAfterAutomaticAssessmentHasFinished = "theSubmitTestResultsAreOnlyDisplayedAfterAutomaticAssessmentHasFinished",

  theReleaseIsStillOpen = "theReleaseIsStillOpen",
  theReleaseIsStillOpenOrAssessmentNotYetFinished = "theReleaseIsStillOpenOrAssessmentNotYetFinished",
  tutorNormalTests = "tutorNormalTests",
  tutorSubmitTests = "tutorSubmitTests",

  //manageOwnOrGroupExerciseComponents
  isOnlyVisibleToOwner = "isOnlyVisibleToOwner",
  solutions = "solutions",
  releases = "releases",
  copyExercise = "copyExercise",
  copyExercise_helpText = "copyExercise_helpText",
  deleteExerciseOnlyIfNoReleasesLeft = "deleteExerciseOnlyIfNoReleasesLeft",


  //submissionsSite
  refreshViw = "refreshViw",
  exportAssessments = "exportAssessments",
  downloadAllSubmissions = "downloadAllSubmissions",
  rerunAutomaticAssessment = "rerunAutomaticAssessment",
  rerunAutomaticAssessment_helpText = "rerunAutomaticAssessment_helpText",
  normalTestsAssessment_helpText = "normalTestsAssessment_helpText",
  submissionTestsAssessment_helpText = "submissionTestsAssessment_helpText",
  download = "download",
  rerunSingleAutomaticAssessment = "rerunSingleAutomaticAssessment",
  openTutorView = "openTutorView",
  openTutorView_helpText = "openTutorView_helpText",
  submissionsOf = "submissionsOf",
  shouldNotCount = "shouldNotCount",
  participationCount_helpText = "participationCount_helpText",

  //---assessment states
  sillReleased = "sillReleased",
  automaticAssessmentOptionNotSelected = "automaticAssessmentOptionNotSelected",
  automaticAssessmentHasNotRanYet = "automaticAssessmentHasNotRanYet",
  notReleasedYet = "notReleasedYet",
  automaticAssessmentIsCurrentlyRunning = "automaticAssessmentIsCurrentlyRunning",
  automaticAssessmentHasFinished = "automaticAssessmentHasFinished",
  manualStartedAssessmentHasFinished = "manualStartedAssessmentHasFinished",
  automaticAssessmentHasFinishedWithErrors = "automaticAssessmentHasFinishedWithErrors",

  automaticRefreshView = "automaticRefreshView",
  automaticRefreshViewIn = "automaticRefreshViewIn",

  releaseStillActiveButUserNormalTestResultsAreDisplayed = "releaseStillActiveButUserNormalTestResultsAreDisplayed",
  releaseStillActiveButUserNormalTestResultsAreDisplayed_helpText = "releaseStillActiveButUserNormalTestResultsAreDisplayed_helpText",

  //releasesSite
  releasesFor = "releasesFor",

  createRelease = "createRelease",
  changeRelease = "changeRelease",
  releaseIsActive = "releaseIsActive",
  releaseIsVisibleForAll = "releaseIsVisibleForAll",
  releaseIsVisibleForAll_helpText = "releaseIsVisibleForAll_helpText",
  automatic = "automatic",
  unlimitedWorkingTime = "unlimitedWorkingTime",
  startAt = "startAt",
  startAt_helpText = "startAt_helpText",
  endAt = "endAt",

  //changeExerciseReleaseDialog
  startAndEndOfTheRelease = "startAndEndOfTheRelease",
  automaticStartAt = "automaticStartAt",
  automaticEndAt = "automaticEndAt",
  durationOfTheAutomaticRelease = "durationOfTheAutomaticRelease",
  durationOfTheAutomaticReleaseInfinitely_helpText = "durationOfTheAutomaticReleaseInfinitely_helpText",
  infinitely = "infinitely",
  limited = "limited",
  options = "options",
  examOptions = "examOptions",
  hints = "hints",
  shouldRunAutomaticAssessment = "shouldRunAutomaticAssessment",
  shouldRunAutomaticAssessment_helpText = "shouldRunAutomaticAssessment_helpText",
  shouldRunNormalTestsAlso = "shouldRunNormalTestsAlso",
  shouldRunNormalTestsAlso_helpText = "shouldRunNormalTestsAlso_helpText",


  //custom projects sites
  manageCustomProjectsSite = "manageCustomProjectsSite",
  createCustomProject = "createCustomProject",
  numCustomProjectsLeft = "numCustomProjectsLeft",
  couldNotLoadCustomProjectOverviews = "couldNotLoadCustomProjectOverviews",
  couldNotDeleteCustomProject = "couldNotDeleteCustomProject",

  deleteCustomProject_title = "deleteCustomProject_title",
  deleteCustomProject_content = "deleteCustomProject_content",

  //manual assessment states
  isReleased = "isReleased",
  isReleased_helpText = "isReleased_helpText",
  automaticAssessmentIsRunning = "automaticAssessmentIsRunning",

  releaseState_automaticTestsWillRun = "releaseState_automaticTestsWillRun",
  releaseState_automaticTestsWontRun = "releaseState_automaticTestsWontRun",
  allPLangs = "allPLangs",

  hasLimitedWorkingTime = "hasLimitedWorkingTime",

  changeUserData = "changeUserData",
  resetPassword = "resetPassword",
  generatedPassword = "generatedPassword",
  generatedPassword_helpText = "generatedPassword_helpText",

  noThemeSelected = "noThemeSelected",
  changeTagIcon_helpText = "changeTagIcon_helpText",
  changeTagDescription_helpText = "changeTagDescription_helpText",

  allWhitespacesOfTheInputAreReplaced = "allWhitespacesOfTheInputAreReplaced",
  allWhitespacesOfTheOutputAreReplaced = "allWhitespacesOfTheOutputAreReplaced",


  couldNotGetHtmlElementWithSpecificId = "couldNotGetHtmlElementWithSpecificId",
  couldNotGetPLangForSolution = "couldNotGetPLangForSolution",

  editorFileNotFound = "editorFileNotFound",
  couldNotFindCodeTemplate = "couldNotFindCodeTemplate",
  someUrlParametersNotFound = "someUrlParametersNotFound",
  probablyNoTestRun = "probablyNoTestRun",
  plangIdNotFound = "plangIdNotFound",

  couldNotFindSolutionFile = "couldNotFindSolutionFile",
  couldNotConvertStringToInt = "couldNotConvertStringToInt",
  couldNotFindRelease = "couldNotFindRelease",
  somethingWentWrongCalculatingLeftWorkingTime = "somethingWentWrongCalculatingLeftWorkingTime",

  autoSaveFilesOnTestRunIfNecessary = "autoSaveFilesOnTestRunIfNecessary",

  submitTestResultStudentHelp = "submitTestResultStudentHelp",
  feedbackFromTutorStudentHelp = "feedbackFromTutorStudentHelp",

  whenAreManualPointsOrFeedbackIsDisplayed_tutor_helpText = "whenAreManualPointsOrFeedbackIsDisplayed_tutor_helpText",

  assessmentStatisticsForUser = "assessmentStatisticsForUser",
  myAssessmentStatisticsForUser = "myAssessmentStatisticsForUser",
  myAssessmentStatisticsForUser_description_home = "myAssessmentStatisticsForUser_description_home",

  //--- custom projects
  manageCustomProjects = "manageCustomProjects",


  //---assessment statistics
  exercise = "exercise",
  exerciseDescription = "exerciseDescription",

  lastUpdatedAtSolutionVersion_helpText = "lastUpdatedAtSolutionVersion_helpText",

  clearCustomTestResults = "clearCustomTestResults",
  clearNormalTestResults = "clearNormalTestResults",
  clearSubmitTestResults = "clearSubmitTestResults",

  noAutomaticTestResultReset = "noAutomaticTestResultReset",

  automaticRelease_helpText = "automaticRelease_helpText",

  tagsFilter = "tagsFilter",
  tagFilter_helpText = "tagFilter_helpText",

  doEditorRemainingTime_helpText = "doEditorRemainingTime_helpText",
  doEditorRemainingTime_helpText_part2 = "doEditorRemainingTime_helpText_part2",

  consoleArguments_helpText = "consoleArguments_helpText",
  compileSingleFileSuccessful = "compileSingleFileSuccessful",

  couldNotFindExercise = 'couldNotFindExercise',
  couldNotFindExerciseOrNoPermission = 'couldNotFindExerciseOrNoPermission',
  couldNotRestoreEditorSessionsBecauseMultipleMatchingFilesFound = "couldNotRestoreEditorSessionsBecauseMultipleMatchingFilesFound",
  couldNotRestoreEditorSessionsBecauseMultipleNoFileFound = "couldNotRestoreEditorSessionsBecauseMultipleNoFileFound",

  couldNotCreateNewFileBecauseFileWithSameNameAlreadyExists = "couldNotCreateNewFileBecauseFileWithSameNameAlreadyExists",

  solutionServerVersionCreatedAt = "solutionServerVersionCreatedAt",
  solutionServerVersionCreatedAt_helpText = "solutionServerVersionCreatedAt_helpText",

  timeUsedUp = "timeUsedUp",
  parseError = "parseError",
  regexError = "regexError",

  escapeEditor = "escapeEditor",
  escapeEditorResult = "escapeEditorResult",

  doExerciseShouldNotCount = "doExerciseShouldNotCount",
  doExerciseShouldNotCount_helpText = "doExerciseShouldNotCount_helpText",
  shouldNotCount_helpText_tutor_helpText = "shouldNotCount_helpText_tutor_helpText",

  doExerciseShouldNotCount_title = "doExerciseShouldNotCount_title",
  doExerciseShouldNotCount_content = "doExerciseShouldNotCount_content",

  couldNotSetShouldNotCount_doExercise = "couldNotSetShouldNotCount_doExercise",

  editorExercise_loadingTestAssetContents = "editorExercise_loadingTestAssetContents",
  editorExercise_couldNotLoadTestAssetContents = "editorExercise_couldNotLoadTestAssetContents",

  couldNotCreateCustomProjectBecauseExceededMaxAmount = "couldNotCreateCustomProjectBecauseExceededMaxAmount",

  couldNotLoadCustomProject = "couldNotLoadCustomProject",

  createdCustomTest = "createdCustomTest",
  updatedCustomTest = "updatedCustomTest",
  deletedCustomTest = "deletedCustomTest",

  couldNotCreateCustomTest = "couldNotCreateCustomTest",
  couldNotUpdateCustomTest = "couldNotUpdateCustomTest",
  couldNotDeleteCustomTest = "couldNotDeleteCustomTest",



  serverSettings = "serverSettings",
  testServerSettings = "testServerSettings",
  logicalUsageStatistic = "logicalUsageStatistic",
  property = "property",
  value = "value",

  hardwareCharts = "hardwareCharts",
  cpuUsageChartCaption = "cpuUsageChartCaption",
  ramUsageChartCaption = "ramUsageChartCaption",
  free = "free",
  liveRefresh_helpText = "liveRefresh_helpText",

  downloadEditExerciseAssets_helpText = "downloadEditExerciseAssets_helpText",

  hideReleaseInOverviews = "hideReleaseInOverviews",
  hideReleaseInOverviews_column = "hideReleaseInOverviews_column",
  hideReleaseInOverviews_helpText = "hideReleaseInOverviews_helpText",

  shouldClearClipboardOnFocus = "shouldClearClipboardOnFocus",
  shouldClearClipboardOnFocus_column = "shouldClearClipboardOnFocus_column",
  shouldClearClipboardOnFocus_helpText = "shouldClearClipboardOnFocus_helpText",

  doExerciseLinkExamMode_hint = "doExerciseLinkExamMode_hint",
  hideSiteHeaderBar =  "hideSiteHeaderBar",
  hideSiteHeaderBar_helpText = "hideSiteHeaderBar_helpText",



}


export type LangTranslation = {
  readonly [id: string]: string
}