/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../state/reducers/index";
import {Dimmer, Loader} from "semantic-ui-react";
import {translate} from "../../../i18n/translationHelper";
import {TranslateIds} from "../../../i18n/ids";

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
  readonly opacity?: number
}

const mapStateToProps = (rootState: RootState , props: MyProps) => {
  return {
    //test0: rootState...
    //test: props.test
    opacity: props.opacity
  }
}

const mapDispatchToProps = (dispatch: Dispatch<any>) => bindActionCreators({
  //imported reducer funcs here

}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class Spinner extends React.Component<Props, any> {
  render(): JSX.Element {
    return (
      <div>
        <Dimmer active inverted style={{opacity: this.props.opacity}} >
          <Loader inverted content={translate(TranslateIds.loading)} />
        </Dimmer>
      </div>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(Spinner)