/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../state/reducers/index";
import MaterialInput from './materialInput'
import {MyProps} from './materialInput'
import {HTMLAttributes} from "react";
import {translate} from "../../../i18n/translationHelper";
import {TranslateIds} from "../../../i18n/ids";

//const css = require('./styles.styl');


const mapStateToProps = (rootState: RootState , props: MyProps & HTMLAttributes<HTMLInputElement>) => {
  return {
    ...props,
    placeholder: props.placeholder,
    value: props.value,
    disabled: props.disabled,
  }
}

const mapDispatchToProps = (dispatch: Dispatch<any>) => bindActionCreators({
  //imported reducer funcs here

}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

//HTMLAttributes
class materialSearchInput extends React.Component<Props, any> {
  render(): JSX.Element {
    return (
      <MaterialInput {...this.props}
                     icon="search"
                     placeholder={`${translate(TranslateIds.search)}...`}
                     disabled={this.props.disabled}
                     value={this.props.value}
      />
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(materialSearchInput)