/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../state/reducers/index";

//const css = require('./styles.styl');

export interface MyProps {
  /**
   * optional header bar of the site
   */
  readonly headerBar?: JSX.Element
}

const mapStateToProps = (rootState: RootState, props: MyProps) => {
  return {
    //test0: rootState...
    //test: props.test
    headerBar: props.headerBar,
    isSubHeaderBarCollapsed: rootState.siteHeaderBarState.isSubHeaderBarCollapsed
  }
}

const mapDispatchToProps = (dispatch: Dispatch<any>) => bindActionCreators({
  //imported reducer funcs here

}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

/**
 * provides padding for the site content (padding the size of the main app header bar)
 * provides also scrolling for the site content
 */
class PageContentWrapper extends React.Component<Props, any> {
  render(): JSX.Element {
    return (
      <div className="fh">
        {
          this.props.headerBar &&
          this.props.headerBar
        }

        <div className={'fh' + (this.props.headerBar && !this.props.isSubHeaderBarCollapsed ? ' header-bar-offset' : '')}>
          <div className="fh scrollable">
            {this.props.children}
          </div>
        </div>
      </div>

    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(PageContentWrapper)