/**
 * Created by janis dähne.
 */

import * as React from "react";
import {HelpPopup} from "../../helpers/helpPopup";


interface MyProps {
  readonly title?: string
  readonly icon?: string
  readonly isActive: boolean
  readonly onClick: () => void
  readonly defaultHelpText?: string
}

//internal for panel to wrap the tab header bar
export default class TabHeader extends React.Component<MyProps, any> {

  handleClicked(): void {
    this.props.onClick()
  }

  render(): JSX.Element {
    return (
      <div onClick={() => this.handleClicked()}
           className={
             this.props.isActive
               ? 'tab-header toggled-active--color'
               : 'tab-header clickable'
           }
      >
        <div className="flexed">
          {
            this.props.icon &&
            <i className={this.props.icon + ' icon'}/>
          }
          {
            //TODO if we have only icon and no text but defaultHelpText then this would look ugly...
            this.props.title &&
            <div className={this.props.defaultHelpText ? "mar-right-half" : null}>
              {
                this.props.title
              }
            </div>
          }

          {
            this.props.defaultHelpText &&
            <HelpPopup defaultText={this.props.defaultHelpText} wide/>
          }

        </div>
      </div>
    )
  }
}