/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../state/reducers/index";
import {MyProps} from './renderWrapper'
import {escapeHtml} from "../../helpers/stringHelper";
import Logger from "../../helpers/logger";

//const css = require('./styles.styl');

const mapStateToProps = (rootState: RootState , props: MyProps) => {
  return {
    //test0: rootState...
    //test: props.test
    contentType: props.contentType,
    content: props.content,
    assets: props.assets,
    dummy: props.dummy
  }
}

const mapDispatchToProps = (dispatch: Dispatch<any>) => bindActionCreators({
  //imported reducer funcs here

}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class textRenderer extends React.Component<Props, any> {

  //TODO move this to some helper
  plainTextToHtmlPlainFilter(text:string):string {

    //escape
    // noinspection TsLint
    let temp = text
    temp = escapeHtml(temp)
    temp = temp.split('\n').join('<br />')
    return temp
  }

  render(): JSX.Element {

    Logger.debug("textRenderer", "rendering...")

    const content = {
      __html: this.plainTextToHtmlPlainFilter(this.props.content)
    }

    return (
      <div className="fh full-w">
        <div dangerouslySetInnerHTML={content}>

        </div>
      </div>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(textRenderer)