/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../state/reducers/index";
import {Segment} from "semantic-ui-react";

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
  /**
   * true: full site absolute positioned,
   * false: match content
   */
  readonly isFullSite?: boolean

  readonly outerClassName?: string
}

const mapStateToProps = (rootState: RootState, props: MyProps) => {
  return {
    //test0: rootState...
    //test: props.test
    ...props

  }
}

const mapDispatchToProps = (dispatch: Dispatch<any>) => bindActionCreators({
  //imported reducer funcs here

}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class singlePanelSiteWrapper extends React.Component<Props, any> {
  render(): JSX.Element {
    return (
      <div className={`fh ${this.props.outerClassName}`}>
        <div className="content-padding">
          <Segment
            className={this.props.isFullSite ? 'full-site-dialog' : ''}
          >
            {this.props.children}
          </Segment>
        </div>
      </div>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(singlePanelSiteWrapper)