/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../../../state/reducers/index";
import {SimpleVDivider} from "../../../helpers/simpleVDivider";
import CommonHeaderBarContentWrapper from '../../../commonHeaderBarContentWrapper'
import {
  setClosedExercisesSiteViewState,
  setIsTagsFilterDisplayed
} from "../../../../state/actions/allAccessibleExercises/closedExercisesSite/closedExercisesSiteActions";
import ViewStateChanger from '../../../helpers/viewStateChanger'
import {Link} from "react-router-dom";
import {Icon} from "semantic-ui-react";

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
}

const mapStateToProps = (rootState: RootState /*, props: MyProps*/) => {
  return {
    //test0: rootState...
    //test: props.test
    viewState: rootState.closedExercisesState.viewState,
    isLoading: rootState.closedExercisesState.isLoading,
    isTagsFilterDisplayed: rootState.closedExercisesState.isTagsFilterDisplayed,
  }
}

const mapDispatchToProps = (dispatch: Dispatch<any>) => bindActionCreators({
  //imported reducer funcs here
  setViewState: setClosedExercisesSiteViewState,
  setIsTagsFilterDisplayed
}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class HeaderBar extends React.Component<Props, any> {
  render(): JSX.Element {

    // const leftArea = (
    //   <div>
    //     <Link to={constants.openExercisesLinkPath}>
    //       <div>
    //         <Icon name="unlock"/>
    //         <span>
    //           <Translate id="openExercises" defaultMessage="Open Exercises"/>
    //       </span>
    //       </div>
    //     </Link>
    //
    //     <SimpleVDivider className="site-content-header-height"/>
    //
    //     <div className="toggled-active--color">
    //       <Icon name="lock"/>
    //       <span>
    //       <Translate id="closedExercises" defaultMessage="Closed Exercises"/>
    //       </span>
    //     </div>
    //   </div>
    // )

    const rightArea = (
      <div className="flexed">

        <div className={`clickable mar-right-half ${this.props.isTagsFilterDisplayed ? 'toggled-colored' : ''}`}
             onClick={() => {
               this.props.setIsTagsFilterDisplayed(!this.props.isTagsFilterDisplayed)
             }}
        >
          <Icon name="filter" />
        </div>

        <ViewStateChanger viewState={this.props.viewState}
                          setViewStateFunc={(viewState) => this.props.setViewState(viewState)}/>
      </div>
    )

    return (
      <CommonHeaderBarContentWrapper rightArea={rightArea} disabled={this.props.isLoading}/>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(HeaderBar)