/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../../../state/reducers/index";
import EnterReleaseCodeView from './enterReleaseCodeView'
import {Divider} from "semantic-ui-react";
import CancelButton from "../../../buttons/cancelButton";
import {setIsEnterReleaseCodeDialogDisplayed} from "../../../../state/actions/allAccessibleExercises/openExercisesSite/openExercisesSiteActions";
import {resetEnterReleaseCodeDialog} from "../../../../state/actions/allAccessibleExercises/openExercisesSite/enterReleaseCodeDialog/enterReleaseCodeDialogActions";
import {translate} from "../../../../../i18n/translationHelper";
import {TranslateIds} from "../../../../../i18n/ids";

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
}

const mapStateToProps = (rootState: RootState /*, props: MyProps*/) => {
  return {
    //test0: rootState...
    //test: props.test
  }
}

const mapDispatchToProps = (dispatch: Dispatch<any>) => bindActionCreators({
  //imported reducer funcs here
  setIsEnterReleaseCodeDialogDisplayed,
   resetEnterReleaseCodeDialog
}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class enterReleaseCodeDialog extends React.Component<Props, any> {

  componentWillMount(): void {
    this.props.resetEnterReleaseCodeDialog()
  }

  render(): JSX.Element {
    return (
      <div>
        <div className="view-padding">
          <div>
            <div className="view-caption">
              <h2>
                {
                  translate(TranslateIds.enterReleaseCode)
                }
              </h2>
            </div>
          </div>

          <div className="view-content">
            <EnterReleaseCodeView/>

            <Divider/>

            <div className="flexed">
              <CancelButton onClick={() => {
                this.props.resetEnterReleaseCodeDialog()
                this.props.setIsEnterReleaseCodeDialogDisplayed(false)
              }}/>
            </div>

          </div>
        </div>
      </div>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(enterReleaseCodeDialog)