/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../../../state/reducers/index";
import MaterialInput from '../../../material/materialInput'
import {Button} from "semantic-ui-react";
import {
  accessExerciseWithCodeAsync,
  setReleaseCode
} from "../../../../state/actions/allAccessibleExercises/openExercisesSite/enterReleaseCodeDialog/enterReleaseCodeDialogActions";
import {Form} from "semantic-ui-react";
import {
  validationRules,
  validationMessageKeys
} from "../../../../state/reducers/allAccessibleExercises/openExercisesSite/enterReleaseCodeDialog/enterReleaseCodeDialogReducer";

import history from '../../../../routerHistory'
import {getDoExerciseSiteToLink} from '../../../../constants'
import {translate} from "../../../../../i18n/translationHelper";
import {TranslateIds} from "../../../../../i18n/ids";

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
}

const mapStateToProps = (rootState: RootState /*, props: MyProps*/) => {
  return {
    //test0: rootState...
    //test: props.test
    dialogState: rootState.enterReleaseCodeDialogState
  }
}

const mapDispatchToProps = (dispatch: Dispatch<any>) => bindActionCreators({
  //imported reducer funcs here
  setReleaseCode,
  accessExerciseWithCodeAsync,
}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class EnterReleaseCodeView extends React.Component<Props, any> {
  render(): JSX.Element {
    return (
      <div>

        <div className="ui form">

          <div>
            <Form.Field required>
              <label>
                {
                  translate(TranslateIds.releaseCode)
                }
                </label>
              <div className="two-flexed-stretch-left">
                <MaterialInput className="mar-right"
                               value={this.props.dialogState.releaseCode}
                               onChange={(e) => this.props.setReleaseCode(e.currentTarget.value)}
                               validations={validationRules.releaseCode}
                               validationMessageKey={validationMessageKeys.releaseCode}
                />
                <Button circular icon='arrow right'
                        className={this.props.dialogState.isValid ? null : 'div-disabled'}
                        onClick={async () => {

                          try {
                            await this.props.accessExerciseWithCodeAsync(this.props.dialogState.releaseCode)
                            history.push(getDoExerciseSiteToLink(this.props.dialogState.releaseCode))
                          } catch(err) {
                            //error message is not shown here but in accessExerciseWithCodeAsync
                          }

                        }}
                />
              </div>
            </Form.Field>

          </div>
        </div>
      </div>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(EnterReleaseCodeView)