/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../../state/reducers";
import {Segment} from 'semantic-ui-react'

import ServerSettingsView from './serverSettingsView'
import LogicalUsageView from './logicalUsageView'
import SinglePanelSiteWrapper from '../../singlePanelSiteWrapper'
import {loadDashboardSite} from "../../../state/actions/dashboardSite/dashboardSiteActions";
import HardwareUsageView from './hardwareUsageView'
import {getHardwareUsageAsync} from "../../../state/actions/dashboardSite/dashboardCrudActions";
import TestServerSettingsView from './testServerSettingsView'

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
}

const mapStateToProps = (rootState: RootState /*, props: MyProps*/) => {
  return {
    //test0: rootState...
    //test: props.test
  }
}

const mapDispatchToProps = (dispatch: Dispatch<any>) => bindActionCreators({
  //imported reducer funcs here

  loadDashboardSite,
  getHardwareUsageAsync

}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;


// noinspection TsLint
let intervalHandle: number = null

export const dashboardRefreshIntervalInS = 5

class dashboardSite extends React.Component<Props, any> {

  async componentWillMount(): Promise<void> {

    await this.props.loadDashboardSite()

    intervalHandle = setInterval(async () => {
      await this.props.getHardwareUsageAsync()
    }, dashboardRefreshIntervalInS * 1000)

  }

  componentWillUnmount(): void {

    if (intervalHandle) {
        clearInterval(intervalHandle)
    }

  }


  render(): JSX.Element {
    return (
      <div className="multiple-single-panels">

        <HardwareUsageView />

        <LogicalUsageView/>

        <ServerSettingsView/>

        <TestServerSettingsView/>

      </div>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(dashboardSite)