/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../../state/reducers";
import {Table} from "semantic-ui-react";
import SinglePanelSiteWrapper from '../../singlePanelSiteWrapper'
import {translate} from "../../../../i18n/translationHelper";
import {TranslateIds} from "../../../../i18n/ids";
import Spinner from "../../helpers/Spinner";

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
}

const mapStateToProps = (rootState: RootState /*, props: MyProps*/) => {
  return {
    //test0: rootState...
    //test: props.test
    serverSettings: rootState.dashboardSiteState.clientServerSettings,
    isLoading: rootState.dashboardSiteState.isLoading,
  }
}

const mapDispatchToProps = (dispatch: Dispatch<any>) => bindActionCreators({
  //imported reducer funcs here

}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

interface Pair {
  readonly property: string
  readonly value: string
}

class serverSettingsView extends React.Component<Props, any> {
  render(): JSX.Element {

    const list: ReadonlyArray<Pair> = this.props.serverSettings === null ? [] : Object.keys(
      this.props.serverSettings).map(p => {

      const pair: Pair = {
        property: p,
        value: this.props.serverSettings[p]
      }
      return pair

    })

    return (
      <SinglePanelSiteWrapper>

        {
          this.props.isLoading &&
          <Spinner/>
        }


        <div className="view-padding">

          <div className="view-head-line">

            <div className="view-caption">
              <h2>
                {
                  translate(TranslateIds.serverSettings)
                }
              </h2>
            </div>

            <div className="view-options">

            </div>
          </div>

          <div className="view-content">

            <Table sortable selectable padded striped singleLine className="material-table">
              <Table.Header>
                <Table.Row>
                  <Table.HeaderCell>
                <span>
                  {
                    translate(TranslateIds.property)
                  }
                </span>
                  </Table.HeaderCell>

                  <Table.HeaderCell>
                <span>
                  {
                    translate(TranslateIds.value)
                  }
                </span>
                  </Table.HeaderCell>
                </Table.Row>
              </Table.Header>

              <Table.Body>
                {
                  list.map((pair, index) => {
                    return (
                      <Table.Row key={pair.property}>

                        <Table.Cell>
                          <span>{pair.property}</span>
                        </Table.Cell>

                        <Table.Cell>
                          <span>
                             {
                               (pair.value !== null && pair.value !== undefined) ? pair.value.toString() : pair.value
                             }
                          </span>
                        </Table.Cell>

                      </Table.Row>
                    )
                  })
                }

              </Table.Body>

            </Table>

          </div>
        </div>


      </SinglePanelSiteWrapper>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(serverSettingsView)