/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../../../state/reducers/index";
import {Form} from "semantic-ui-react";
import MaterialInput from '../../../material/materialInput'
import {translate} from "../../../../../i18n/translationHelper";
import {TranslateIds} from "../../../../../i18n/ids";

import MaterialTextArea from '../../../material/materialTextArea'

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
}

const mapStateToProps = (rootState: RootState /*, props: MyProps*/) => {
  return {
    //test0: rootState...
    //test: props.test
    assessmentResult: rootState.doExerciseSiteState.assessmentResult
  }
}

const mapDispatchToProps = (dispatch: Dispatch<any>) => bindActionCreators({
  //imported reducer funcs here

}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class assessmentResultPanelView extends React.Component<Props, any> {
  render(): JSX.Element {

    return (
      <div>
        <div className="ui form">
          <Form.Field>
            <label>
              {
                translate(TranslateIds.feedback)
              }
            </label>

            <MaterialTextArea rows={3}
              value={this.props.assessmentResult.feedbackForStudent}
                              readonly
            />
          </Form.Field>

        </div>
      </div>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(assessmentResultPanelView)