/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {CSSProperties} from "react";


//require('./weightIndicatorBackgroundBar.styl')

export interface MyProps {
  readonly value: number
  readonly maxValue: number
  readonly indicatorColor?: string
}

/**
 * an indicator progress bar to display percentage
 *
 * this is like in karent.jp the background progress bar
 *
 * usage:
 * the parent element needs to be relative positioned (OR use the indicator-parent rule)
 * if the bar has a sibling (e.g. something should be displayed above the indicator bar)
 * then the sibling needs to have a z-index > 1 and needs to be relative positioned (OR use the indicator-sibling css rule)
 *
 * e.g.
 *
 * <List.Item className={`indicator-parent`}>
 *   <IndicatorProgressBar value={test.weight}
 *      maxValue={maxSummedPoints}
 *    />
 *    <List.Content className="indicator-sibling">
 *      ...
 *     </List.Content>
 * </List.Item>
 * @param {MyProps} props
 * @returns {any}
 * @constructor
 */
const IndicatorProgressBar: React.SFC<any> = (props: MyProps) => {

  // noinspection TsLint
  const percentage = props.value * 100 / props.maxValue
  // noinspection TsLint
  const indicatorStyle: CSSProperties = {
    backgroundColor: props.indicatorColor ? props.indicatorColor : null,
    position: 'absolute',
    left: '0',
    right: `${100-percentage}%`,
    top: '0',
    bottom: '0',
  }

  return (
    <div className="weight-indicator-bar">

      <div className="indicator" style={indicatorStyle}>
        {

        }
      </div>

    </div>
  )
}

export default IndicatorProgressBar