/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../../../state/reducers/index";
import {Form, Checkbox, Radio} from "semantic-ui-react";
import {translate} from "../../../../../i18n/translationHelper";
import {TranslateIds} from "../../../../../i18n/ids";
import MaterialInput from '../../../material/materialInput'
import {setCustomProjectDisplayName} from "../../../../state/actions/editCustomProjectSite/editCustomProjectActions";

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
}

const mapStateToProps = (rootState: RootState /*, props: MyProps*/) => {
  return {
    //test0: rootState...
    //test: props.test
    customProject: rootState.editCustomProjectSiteState.customProject
  }
}

const mapDispatchToProps = (dispatch: Dispatch<any>) => bindActionCreators({
  //imported reducer funcs here
  setCustomProjectDisplayName
}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class propertiesPanelView extends React.Component<Props, any> {
  render(): JSX.Element {
    return (
      <div className="mar-right-half">

        <div className="ui form">

          <Form.Field required>
            <label>
              {
                translate(TranslateIds.displayName)
              }
            </label>
            <MaterialInput
              value={this.props.customProject.displayName}
              onChange={(e) => this.props.setCustomProjectDisplayName(e.currentTarget.value)}
            />
          </Form.Field>
        </div>
      </div>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(propertiesPanelView)