/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../../../state/reducers/index";
import {ExerciseCodeTemplateFullBase} from "../../../../types/exerciseEditor";
import {Table, Checkbox} from "semantic-ui-react";
import {CheckboxOnChangeEventData} from "../../../../types/reactEvents";
import {setCodeTemplates} from "../../../../state/actions/exerciseEditorSite/subSets/editorExerciseCodeTemplatesActions";
import {translate} from "../../../../../i18n/translationHelper";
import {TranslateIds} from "../../../../../i18n/ids";

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
  readonly codeTemplate: ExerciseCodeTemplateFullBase
  readonly allCodeTemplates: ReadonlyArray<ExerciseCodeTemplateFullBase>
}

const mapStateToProps = (rootState: RootState, props: MyProps) => {
  return {
    //test0: rootState...
    //test: props.test
    ...props
  }
}

const mapDispatchToProps = (dispatch: Dispatch<any>) => bindActionCreators({
  //imported reducer funcs here
  setCodeTemplates
}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class codeTemplateDetailsView extends React.Component<Props, any> {
  render(): JSX.Element {
    return (
      <div className="pad-left-right">
        <Table padded striped singleLine className="material-table">
          <Table.Header>
            <Table.Row>
              <Table.HeaderCell>
                <span>
                  {
                    translate(TranslateIds.fileName)
                  }
                </span>
              </Table.HeaderCell>
              <Table.HeaderCell>
                <span>

                  {
                    translate(TranslateIds.changeableByUser)
                  }
                </span>
              </Table.HeaderCell>
            </Table.Row>
          </Table.Header>

          <Table.Body>
            {
              this.props.codeTemplate.templateFiles.map(file => {
                return (
                  <Table.Row key={file.id}>

                    <Table.Cell>
                      {
                        file.fileNameWithExtension
                      }
                    </Table.Cell>

                    <Table.Cell>
                      <div>
                        <Checkbox checked={file.isEditableByUser}
                                  onChange={(event: any, data: CheckboxOnChangeEventData) => {

                                    this.props.setCodeTemplates(
                                      this.props.allCodeTemplates.map(template => {
                                        return template.id === this.props.codeTemplate.id
                                          ? {
                                            ...template,
                                            templateFiles: template.templateFiles.map(tempFile => {
                                              return tempFile.id === file.id
                                                ? {
                                                  ...tempFile,
                                                  isEditableByUser: data.checked
                                                }
                                                : tempFile
                                            })
                                          }
                                          : template
                                      })
                                    )
                                  }}/>
                      </div>

                    </Table.Cell>

                  </Table.Row>
                )
              })
            }
          </Table.Body>

        </Table>

      </div>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(codeTemplateDetailsView)