/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../../../../state/reducers/index";
import FullSiteDialog from '../../../../fullSiteDialog'
import {
  applyChangCodeTemplateDialog,
  cancelEditorTestDialog
} from "../../../../../state/actions/exerciseEditorSite/dialogs/changeCodeTemplateDialog/changeCodeTemplateDialogActions";
import ChangeCodeTemplateView from './changeCodeTemplateView'
import {translate} from "../../../../../../i18n/translationHelper";
import {TranslateIds} from "../../../../../../i18n/ids";

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
}

const mapStateToProps = (rootState: RootState /*, props: MyProps*/) => {
  return {
    //test0: rootState...
    //test: props.test
    isValid: rootState.changeCodeTemplateDialogState.isValid,
    isBusy: rootState.changeCodeTemplateDialogState.isBusy,
    isCreating: rootState.changeCodeTemplateDialogState.isCreating,
    codeTemplate: rootState.changeCodeTemplateDialogState.codeTemplate,
    allCodeTemplates: rootState.exerciseEditorState.editorExercise.codeTemplates
  }
}

const mapDispatchToProps = (dispatch: Dispatch<any>) => bindActionCreators({
  //imported reducer funcs here
  cancelEditorTestDialog,
  applyChangCodeTemplateDialog,
}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class changeCodeTemplateDialog extends React.Component<Props, any> {
  render(): JSX.Element {
    return (
      <FullSiteDialog
        isBusy={this.props.isBusy}
        isValid={this.props.isValid}
        caption={
          <h2>
            {
              this.props.isCreating ? translate(TranslateIds.createTemplate) : translate(TranslateIds.changeTemplate)
            }
          </h2>
        }
        onSave={() => {
          this.props.applyChangCodeTemplateDialog(this.props.codeTemplate, this.props.isCreating,
            this.props.allCodeTemplates)
        }}
        onCancel={() => {
          this.props.cancelEditorTestDialog()
        }}
      >
        <ChangeCodeTemplateView/>
      </FullSiteDialog>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(changeCodeTemplateDialog)