/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../../../state/reducers/index";
import {Icon, Checkbox} from "semantic-ui-react";
import {openEditEditorSettingsDialog} from "../../../../state/actions/editorSettingsDialog/editorSettingsDialogActions";
import {
  setIsChangeExerciseEditorSettingsDialogDisplayed
} from "../../../../state/actions/exerciseEditorSite/exerciseEditorSiteActions";
import {translate} from "../../../../../i18n/translationHelper";
import {TranslateIds} from "../../../../../i18n/ids";
import {SetIsDialogDisplayedActionCallback} from "../../../../state/reducers/editorSettingsDialog/editorSettingsDialogReducer";

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string

  readonly setIsEditorSettingsDialogDisplayed: SetIsDialogDisplayedActionCallback

}

const mapStateToProps = (rootState: RootState , props: MyProps) => {
  return {
    //test0: rootState...
    //test: props.test
    codeEditorSettings: rootState.userDataSettingsSate.userData.settings ?
      rootState.userDataSettingsSate.userData.settings.codeEditorSettings
      : null,

    setIsEditorSettingsDialogDisplayed: props.setIsEditorSettingsDialogDisplayed
  }
}

const mapDispatchToProps = (dispatch: Dispatch<any>) => bindActionCreators({
  //imported reducer funcs here
  openEditEditorSettingsDialog,

}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class DescriptionEditorHeaderBar extends React.Component<Props, any> {
  render(): JSX.Element {
    return (
      <div className="flexed">

        <div className="clickable"
             onClick={() => {
               this.props.openEditEditorSettingsDialog(this.props.codeEditorSettings,
                 this.props.setIsEditorSettingsDialogDisplayed)
             }}
        >
          <Icon name="settings"/>
          <span>
            {
              translate(TranslateIds.editorSettings)
            }
          </span>
        </div>

      </div>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(DescriptionEditorHeaderBar)