/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../../../../state/reducers/index";
import Spinner from "../../../../helpers/Spinner";
import {Divider} from "semantic-ui-react";
import SaveButton from "../../../../buttons/saveButton";
import CancelButton from "../../../../buttons/cancelButton";
import ChangeTestView from './changeTestView'
import SinglePanelSiteWrapper from '../../../../singlePanelSiteWrapper'
import {
  applyChangedEditorTestDialog,
  cancelEditorTestDialog
} from "../../../../../state/actions/exerciseEditorSite/dialogs/changeTestDialog/changeTestDialogActions";
import FullSiteDialog from '../../../../fullSiteDialog'
import {Link} from "react-router-dom";
import * as constants from '../../../../../constants'
import {Icon} from "semantic-ui-react";
import {translate} from "../../../../../../i18n/translationHelper";
import {TranslateIds} from "../../../../../../i18n/ids";

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
}

const mapStateToProps = (rootState: RootState /*, props: MyProps*/) => {
  return {
    //test0: rootState...
    //test: props.test
    isBusy: rootState.changeTestDialogState.isBusy || rootState.testTypesState.isLoading,
    isCreating: rootState.changeTestDialogState.isCreating,
    isValid: rootState.changeTestDialogState.isValid,
    test: rootState.changeTestDialogState.test,
    allTests: rootState.exerciseEditorState.editorExercise.tests

  }
}

const mapDispatchToProps = (dispatch: Dispatch<any>) => bindActionCreators({
  //imported reducer funcs here
  cancelEditorTestDialog,
  applyChangedEditorTestDialog
}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class changeTestDialog extends React.Component<Props, any> {
  render(): JSX.Element {
    return (
        <FullSiteDialog
          isBusy={this.props.isBusy}
          isValid={this.props.isValid}
          caption={
            <div className="flexed">
              <h2 className="mar-right">
                {
                  this.props.isCreating &&
                  (this.props.test.isSubmitTest ? translate(TranslateIds.createSubmitTest) : translate(TranslateIds.createNormalTest))
                }
                {
                  !this.props.isCreating &&
                  (this.props.test.isSubmitTest ? translate(TranslateIds.changeSubmitTest) : translate(TranslateIds.changeNormalTest))
                }
              </h2>

              <Link target="_blank" to={constants.markdownSiteTestSyntaxGuide}
                    style={{marginTop: '0.5em'}}
              >
                <Icon className="mar-right-half" name="external share"/>
                <span>
                  {
                    translate(TranslateIds.openHelpInNewTab)
                  }
                </span>
              </Link>

            </div>
          }
          onSave={() => {
            this.props.applyChangedEditorTestDialog(this.props.test, this.props.isCreating, this.props.allTests)
          }}
          onCancel={() => {
            this.props.cancelEditorTestDialog()
          }}
        >
          <ChangeTestView/>
        </FullSiteDialog>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(changeTestDialog)