/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import Spinner from "../../../helpers/Spinner";
import {RootState} from "../../../../state/reducers/index";
import CancelButton from "../../../buttons/cancelButton";
import {
  createGroupAsync, deleteGroupAsync,
  updateGroupAsync
} from "../../../../state/actions/groupsSite/dialog/groupDialogCrudActions";
import SaveButton from "../../../buttons/saveButton";
import {Divider} from "semantic-ui-react";
import ChangeGroupView from './changeGroupDataView'
import {cancelEditGroup} from "../../../../state/actions/groupsSite/groupsSiteActions";
import {translate} from "../../../../../i18n/translationHelper";
import {TranslateIds} from "../../../../../i18n/ids";

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
}

const mapStateToProps = (rootState: RootState /*, props: MyProps*/) => {
  return {
    //test0: rootState...
    //test: props.test
    dialogState: rootState.changeGroupDialogState,

  }
}

const mapDispatchToProps = (dispatch: Dispatch<any>) => bindActionCreators({
  //imported reducer funcs here
  createGroupAsync,
  updateGroupAsync,
  deleteGroupAsync,
  cancelEditGroup
}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class changeGroupDataDialog extends React.Component<Props, any> {
  render(): JSX.Element {
    return (
      <div>
        {
          this.props.dialogState.isBusy &&
          <Spinner/>
        }

        <div className="view-padding">
          <div>
            <div className="view-caption">
              <h2>
                {
                  this.props.dialogState.isCreating &&
                  translate(TranslateIds.createGroup)
                }
                {
                  !this.props.dialogState.isCreating &&
                  translate(TranslateIds.changeGroup)
                }
              </h2>
            </div>
          </div>

          <div className="view-content">
            <ChangeGroupView/>

            <Divider className="hidden"/>

            <div className="flexed">
              <SaveButton className="mar-right" disabled={!this.props.dialogState.isValid}
                          onClick={() => {

                            if (this.props.dialogState.isCreating) {
                              this.props.createGroupAsync(this.props.dialogState.group)
                            } else {
                              this.props.updateGroupAsync(this.props.dialogState.group)
                            }
                          }}
              ></SaveButton>
              <CancelButton onClick={() => {
                this.props.cancelEditGroup()
              }}/>
            </div>

          </div>
        </div>
      </div>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(changeGroupDataDialog)