/**
 * Created by janis dähne.
 */

import * as React from "react";
import marked = require("marked");
import SinglePanelSiteWrapper from '../../singlePanelSiteWrapper'
import Logger from "../../../helpers/logger";
import {returntypeof} from "react-redux-typescript";
import {RootState} from "../../../state/reducers";
import {bindActionCreators, Dispatch} from "redux";
import {setIsSiteHeaderBarDisplayedAndEnabledAction} from "../../../state/actions/siteHeaderBarActions";
import {connect} from "react-redux";

//const css = require('./styles.styl');
const exerciseSyntaxGuideMd = require('../../../questionSystem/exerciseQuestionSyntaxGuide.md')

export interface MyProps {
  //readonly test: string
}

const mapStateToProps = (rootState: RootState /*, props: MyProps*/) => {
  return {
    //test0: rootState...
    //test: props.test
  }
}

const mapDispatchToProps = (dispatch: Dispatch<any>) => bindActionCreators({
  //imported reducer funcs here

  setIsSiteHeaderBarDisplayedAndEnabledAction

}, dispatch)

const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;



const content = {
  __html: marked(exerciseSyntaxGuideMd)
}

class ExerciseSyntaxSite extends React.Component<Props, any> {

  componentWillMount(): void {

    Logger.log('disabling header bar')
    this.props.setIsSiteHeaderBarDisplayedAndEnabledAction(false)

  }

  render(): JSX.Element {
    return (
      <SinglePanelSiteWrapper>
        <div className="markdown-body" dangerouslySetInnerHTML={content}>

        </div>
      </SinglePanelSiteWrapper>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(ExerciseSyntaxSite)