/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {FormattedMessage} from 'react-intl';
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../../state/reducers/index";
import HomeSiteCard from './homeSiteCard'
import * as constants from "../../../constants";
import {translate} from "../../../../i18n/translationHelper";
import {TranslateIds} from "../../../../i18n/ids";


//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
}

const mapStateToProps = (rootState: RootState /*, props: MyProps*/) => {
  return {
    //test0: rootState...
    //test: props.test
  }
}

const mapDispatchToProps = (dispatch: Dispatch<any>) => bindActionCreators({
  //imported reducer funcs here

}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class HomeSite extends React.Component<Props, any> {
  render(): JSX.Element {
    return (
      <div>

        <div className="home-site-card-list">

          {
            /*
            <HomeSiteCard icon="home" caption="Home" link={constants.homeLinkPath}
                        description={
            'Die Startseite bietet eine kleine Übersicht über alle wichtigen Funkionen (diese Seite).'
          }/>
             */
          }

          <HomeSiteCard icon="block layout" caption={translate(TranslateIds.allOpenExercises)}
                        link={constants.openExercisesLinkPath}
                        description={
                          translate(TranslateIds.allOpenExercises_desc)
                        }/>


          <HomeSiteCard icon="user" cornerIcon="block layout" cornerIconInverted
                        caption={translate(TranslateIds.ownExercises)} link={constants.ownExercisesLinkPath}
                        description={
                          translate(TranslateIds.ownExercises_desc)
                        }/>


          <HomeSiteCard icon="users" cornerIcon="block layout" cornerIconInverted
                        caption={translate(TranslateIds.groupExercises)} link={constants.groupExercisesLinkPath}
                        description={
                          translate(TranslateIds.groupExercises)
                        }/>

          <HomeSiteCard icon="area chart"
                        caption={translate(TranslateIds.myAssessmentStatisticsForUser)} link={constants.assessmentStatisticsSiteToLinkPath}
                        description={
                          translate(TranslateIds.myAssessmentStatisticsForUser_description_home)
                        }/>


        </div>

      </div>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(HomeSite)