/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../../state/reducers/index";
import {SimpleVDivider} from '../../helpers/simpleVDivider'
import {Icon, SemanticICONS} from "semantic-ui-react";
import {Link} from "react-router-dom";

//const css = require('./styles.styl');

export interface MyProps {
  readonly link: string
  readonly icon: SemanticICONS
  readonly cornerIcon?: SemanticICONS
  readonly cornerIconInverted?: boolean
  readonly caption: string
  readonly description: string
}

const mapStateToProps = (rootState: RootState, props: MyProps) => {
  return {
    //test0: rootState...
    //test: props.test
    ...props
  }
}

const mapDispatchToProps = (dispatch: Dispatch<any>) => bindActionCreators({
  //imported reducer funcs here

}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class homeSiteCard extends React.Component<Props, any> {
  render(): JSX.Element {
    return (
      <div className="home-site-card card-shadow">

        <Link to={this.props.link} className="header-menu-item">
          <Icon.Group size='huge'>
            <Icon name={this.props.icon}/>
            {
              this.props.cornerIcon &&
              <Icon corner inverted={(this.props.cornerIconInverted === true || this.props.cornerIconInverted === false) ? this.props.cornerIconInverted : null}
                    name={this.props.cornerIcon}/>
            }
          </Icon.Group>
        </Link>


        <SimpleVDivider/>
        <div>
          <h3>{this.props.caption}</h3>
          <span>
            {this.props.description}
          </span>
        </div>

      </div>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(homeSiteCard)