/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../../state/reducers/index";
import {Icon} from "semantic-ui-react";
import {SimpleVDivider} from "../../helpers/simpleVDivider";
import CommonHeaderBarContentWrapper from '../../commonHeaderBarContentWrapper'
import {
  activateMultipleNewUserAsync,
  deleteMultipleNewUserAsync
} from "../../../state/actions/manageNewUsersSite/manageNewUserSiteCrudActions";
import {translate} from "../../../../i18n/translationHelper";
import {TranslateIds} from "../../../../i18n/ids";

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
}

const mapStateToProps = (rootState: RootState /*, props: MyProps*/) => {
  return {
    //test0: rootState...
    //test: props.test
    isLoading: rootState.manageNewUsersState.isLoading,
    newUsers: rootState.manageNewUsersState.newUsers,
    systemRole: rootState.userDataSettingsSate.userData
    && rootState.userDataSettingsSate.userData.systemRole
      ? rootState.userDataSettingsSate.userData.systemRole
      : null,
  }
}

const mapDispatchToProps = (dispatch: Dispatch<any>) => bindActionCreators({
  //imported reducer funcs here
  activateMultipleNewUserAsync,
  deleteMultipleNewUserAsync
}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class headerBar extends React.Component<Props, any> {


  render(): JSX.Element {

    const isSomeUserSelected = this.props.newUsers.some(p => p.uiIsSelected)

    const leftArea = (
      <div>
        {
          (this.props.systemRole && this.props.systemRole.canManageNewUsers) &&
          <div className={isSomeUserSelected ? 'clickable' : 'div-disabled'}
               onClick={() =>
                 this.props.activateMultipleNewUserAsync(
                   this.props.newUsers
                     .filter(p => p.uiIsSelected)
                     .map(p => {
                       return {
                         userId: p.id,
                         systemRoleId: p.systemRoleId,
                       }
                     }))
               }>
            <Icon name="checkmark"/>
            <span>
            {
              translate(TranslateIds.activateSelectedUsers)
            }
           </span>
          </div>
        }

        {
          (this.props.systemRole && this.props.systemRole.canManageNewUsers) &&
          <SimpleVDivider/>
        }

        {
          (this.props.systemRole && this.props.systemRole.canManageNewUsers) &&
          <div className={isSomeUserSelected ? 'clickable' : 'div-disabled'}
               onClick={() => {
                 this.props.deleteMultipleNewUserAsync(
                   this.props.newUsers.filter(p => p.uiIsSelected)
                 )
               }}
          >
            <Icon name="remove"/>
            <span>
            {
              translate(TranslateIds.deleteSelectedUsers)
            }
           </span>
          </div>
        }

      </div>
    )


    return (
      <CommonHeaderBarContentWrapper leftArea={leftArea} disabled={this.props.isLoading}/>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(headerBar)