/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../../state/reducers/index";

import SinglePanelSiteWrapper from '../../singlePanelSiteWrapper'
import {Input, Icon} from "semantic-ui-react";

import {Route, RouteComponentProps, withRouter} from 'react-router'

import MaterialSearchInput from '../../material/materialSearchInput'
import NewUsersListView from './newUsersListView'
import Spinner from "../../helpers/Spinner";
import {getNotActivatedUsers} from "../../../communicationLayer/usersLayer";
import {loadManageNewUsersSite} from "../../../state/actions/manageNewUsersSite/manageNewUsersActions";
import {translate} from "../../../../i18n/translationHelper";
import {TranslateIds} from "../../../../i18n/ids";

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
}

const mapStateToProps = (rootState: RootState /*, props: MyProps*/) => {
  return {
    //test0: rootState...
    //test: props.test
    isLoading: rootState.manageNewUsersState.isLoading
  }
}


const mapDispatchToProps = (dispatch: Dispatch<any>) => bindActionCreators({
  //imported reducer funcs here
  loadManageNewUsersSite
}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class ManageUsersSite extends React.Component<Props & RouteComponentProps<any>, any> {

  componentWillMount(): void {
    this.props.loadManageNewUsersSite()
  }


  render(): JSX.Element {
    return (
      <SinglePanelSiteWrapper>

        {
          this.props.isLoading &&
          <Spinner/>
        }

        <div className="view-padding">
          <div className="view-head-line">
            <div className="view-caption">
              <h1>
                {
                  translate(TranslateIds.manageNewUsers)
                }
              </h1>
            </div>
            <div className="view-options">
              <MaterialSearchInput/>
            </div>
          </div>

          <div className="view-content">
            <NewUsersListView/>
          </div>
        </div>

      </SinglePanelSiteWrapper>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(ManageUsersSite)