/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../../../../../state/reducers/index";
import {Form, Checkbox} from "semantic-ui-react";
import MaterialInput from '../../../../../material/materialInput'
import {ReleaseDurationType} from "../../../../../../types/ReleaseDurationType";
import {ReleaseStartType} from "../../../../../../types/ReleaseStartType";
import {displayDateAndTime} from "../../../../../../helpers/convertersAndTransformers";
import {translate} from "../../../../../../../i18n/translationHelper";
import {TranslateIds} from "../../../../../../../i18n/ids";
import {errorDialog} from "../../../../../../helpers/dialogHelper";

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
}

const mapStateToProps = (rootState: RootState /*, props: MyProps*/) => {
  return {
    //test0: rootState...
    //test: props.test
    release: rootState.zoomedExerciseReleaseState.release,
    pLangs: rootState.pLangsState.pLangs
  }
}

const mapDispatchToProps = (dispatch: Dispatch<any>) => bindActionCreators({
  //imported reducer funcs here

}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class ReleaseCodeBigView extends React.Component<Props, any> {



  render(): JSX.Element {


    // noinspection TsLint
    let pLangName = translate(TranslateIds.allPLangs)

    if (this.props.release.pLangId) {
      const pLang = this.props.pLangs.find(p => p.id === this.props.release.pLangId)

      if (pLang) {
        pLangName = pLang.displayName
      } else {
        errorDialog(translate(TranslateIds.error), translate(TranslateIds.plangIdNotFound))
      }
    }


    return (
      <div className="ui form">

        <Form.Group widths='equal'>
          <Form.Field>
            <label>
              {
                translate(TranslateIds.pLang)
              }
            </label>
            <span>
            {
              pLangName
            }
          </span>
          </Form.Field>

          <Form.Field>
            <label>
              {
                translate(TranslateIds.isReleased)
              }
            </label>
            <Checkbox checked={this.props.release.isReleased} disabled/>
          </Form.Field>

          <Form.Field>
            <label>
              {
                translate(TranslateIds.hasLimitedWorkingTime)
              }
            </label>
            <Checkbox checked={this.props.release.hasLimitedWorkingTime} disabled/>
          </Form.Field>

          {
            this.props.release.hasLimitedWorkingTime &&
            <Form.Field>
              <label>
                {
                  translate(TranslateIds.availableWorkingTimeInMin)
                }
              </label>
              <span>
                {this.props.release.availableWorkingTimeInMinutes.toString()}
              </span>
            </Form.Field>
          }
        </Form.Group>

        <Form.Field>
          <label style={{marginBottom: '2em'}}>
            {
              translate(TranslateIds.releaseCode)
            }
          </label>
          <span style={{fontSize: '70px'}}>
            {
              this.props.release &&
              this.props.release.generatedCode
            }
          </span>
        </Form.Field>

        {
          //TODO no easy to translate... and not tested
          /*
          {
          (this.props.release.releaseStartType === ReleaseStartType.Automatic
            && this.props.release.releaseDurationType === ReleaseDurationType.Limited
            && this.props.release.automaticStartAt
            && this.props.release.automaticEndAt
          ) &&
          <Form.Field>
            <p>
              Sie haben von {displayDateAndTime(this.props.release.automaticStartAt, -1)}
              bis {displayDateAndTime(this.props.release.automaticEndAt, -1)} Zeit den Freigabecode einzugeben.
            </p>
          </Form.Field>
        }

        {
          (this.props.release.releaseStartType === ReleaseStartType.Automatic
            && this.props.release.releaseDurationType === ReleaseDurationType.Infinitely
            && this.props.release.automaticStartAt
          ) &&
          <Form.Field>
            <p>
              Sie haben ab {displayDateAndTime(this.props.release.automaticStartAt, -1)} Zeit den Freigabecode einzugeben.
            </p>
          </Form.Field>
        }

        {
          this.props.release.hasLimitedWorkingTime &&
          <Form.Field>
            <p>
              Nach der Eingabe des Freigabecodes haben
              sie {this.props.release.availableWorkingTimeInMinutes.toString()} Minuten Zeit die Aufgabe zu lösen.
            </p>
          </Form.Field>
        }
        {
          !this.props.release.hasLimitedWorkingTime &&
          <Form.Field>
            <p>
              Nach der Eingabe des Freigabecodes haben sie unbegrenzt viel Zeit die Aufgabe zu lösen.
            </p>
          </Form.Field>
        }
           */
        }


      </div>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(ReleaseCodeBigView)