/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../../state/reducers/index";
import CommonHeaderBarContentWrapper from '../../commonHeaderBarContentWrapper'
import {Icon} from "semantic-ui-react";
import {SimpleVDivider} from "../../helpers/simpleVDivider";
import {openCreateTagDialog} from "../../../state/actions/manageTagsSite/manageTagsActions";
import {translate} from "../../../../i18n/translationHelper";
import {TranslateIds} from "../../../../i18n/ids";

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
}

const mapStateToProps = (rootState: RootState /*, props: MyProps*/) => {
  return {
    //test0: rootState...
    //test: props.test
    isChangeDialogDisplayed: rootState.manageTagsState.isChangeDialogDisplayed,
    isLoading: rootState.manageTagsState.isLoading,
  }
}

const mapDispatchToProps = (dispatch: Dispatch<any>) => bindActionCreators({
  //imported reducer funcs here
  openCreateTagDialog
}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class headerBarContent extends React.Component<Props, any> {
  render(): JSX.Element {

    const leftArea = (
      <div>

        <div className="clickable"
             onClick={() => {
               this.props.openCreateTagDialog()
             }}>

          <Icon name="plus"/>
          <span>
            {
              translate(TranslateIds.createTag)
            }
          </span>
        </div>

        <SimpleVDivider/>

        {
          /*
          TODO TICKET
           <div className="clickable div-disabled">
          <Icon name="compress"/>
          <span>
            Tags zusammenführen
          </span>
        </div>
           */
        }

      </div>
    )


    return (
      <CommonHeaderBarContentWrapper leftArea={leftArea} disabled={this.props.isLoading}/>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(headerBarContent)