/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../../../../state/reducers/index";
import SaveButton from "../../../../buttons/saveButton";
import CancelButton from "../../../../buttons/cancelButton";
import {Divider} from "semantic-ui-react";
import Spinner from "../../../../helpers/Spinner";
import AddUserView from './addUserView'
import {SelectableGroupUserFrontend} from "../../../../../types/group";
import {setIsAddUsersDialogDisplayed} from "../../../../../state/actions/singleGroupSite/singleGroupSiteActions";
import {getUsersAsync} from "../../../../../state/actions/singleGroupSite/dialogs/addUsers/addUsersDialogCrudActions";
import {BackArrow} from "../../../../helpers/backArrow";
import {cancelAddUsersDialog} from "../../../../../state/actions/singleGroupSite/dialogs/addUsers/addUsersDialogActions";
import MaterialSearchInput from '../../../../material/materialSearchInput'
import {translate} from "../../../../../../i18n/translationHelper";
import {TranslateIds} from "../../../../../../i18n/ids";

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
}

const mapStateToProps = (rootState: RootState /*, props: MyProps*/) => {
  return {
    //test0: rootState...
    //test: props.test
    isBusy: rootState.addUsersDialogState.isBusy,
    isValid: rootState.addUsersDialogState.isValid,
    currentUserId: rootState.userDataSettingsSate.userData.id,
    members: rootState.singleGroupState.members
  }
}

const mapDispatchToProps = (dispatch: Dispatch<any>) => bindActionCreators({
  //imported reducer funcs here
  setIsAddUsersDialogDisplayed,
  getUsersAsync,
  cancelAddUsersDialog
}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class addUserDialog extends React.Component<Props, any> {

  componentWillMount(): void {
    this.props.getUsersAsync(this.props.currentUserId, this.props.members)
  }

  render(): JSX.Element {
    return (
      <div>
        {
          this.props.isBusy &&
          <Spinner/>
        }

        <div className="view-padding">
          <div className="view-head-line">
            <div className="view-caption">
              <div className="mar-right back-arrow">
                <div className="clickable"
                  onClick={() => {
                    this.props.cancelAddUsersDialog()
                  }}
                >
                  <BackArrow/>
                </div>
              </div>

              <h2 className="clear-margin">

                {
                  translate(TranslateIds.addUsersToGroup)
                }
              </h2>
            </div>
            <div className="view-options">
              <MaterialSearchInput/>
            </div>
          </div>

          <div className="view-content">
            <AddUserView/>
          </div>
        </div>
      </div>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(addUserDialog)