/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../../../../state/reducers/index";
import {Icon} from "semantic-ui-react";
import CommonHeaderBarContentWrapper from '../../../../commonHeaderBarContentWrapper'
import {
  addMembersAndExitAsync,
  cancelAddUsersDialog
} from "../../../../../state/actions/singleGroupSite/dialogs/addUsers/addUsersDialogActions";
import {translate} from "../../../../../../i18n/translationHelper";
import {TranslateIds} from "../../../../../../i18n/ids";
import {askDialog} from "../../../../../helpers/dialogHelper";

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
}

const mapStateToProps = (rootState: RootState /*, props: MyProps*/) => {
  return {
    //test0: rootState...
    //test: props.test
    isBusy: rootState.addUsersDialogState.isBusy,
    selectedGroupId: rootState.singleGroupState.selectedGroupId,
    groups: rootState.singleGroupState.groups,
    users: rootState.addUsersDialogState.users,
    currentUserId: rootState.userDataSettingsSate.userData.id,
    groupRoles: rootState.singleGroupState.groupRoles,
  }
}

const mapDispatchToProps = (dispatch: Dispatch<any>) => bindActionCreators({
  //imported reducer funcs here
  addMembersAndExitAsync,
}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class headerBarContent extends React.Component<Props, any> {
  render(): JSX.Element {

    const group = this.props.groups.find((g) => g.id === this.props.selectedGroupId)
    const selectedUsersIds = this.props.users.filter(p => p.uiIsSelected).map(p => p.id)

    const leftArea = (
      <div>

        <div className={selectedUsersIds.length > 0 ? 'clickable' : 'div-disabled'}
             onClick={async () => {


               // noinspection TsLint
               let shouldAdd = false

               // if (selectedUsersIds.length > 1) {

                 shouldAdd = await askDialog(translate(TranslateIds.addUsersToGroup_title),
                   `${translate(TranslateIds.addUsersToGroup_content)} (${selectedUsersIds.length} users)`
                 )
               // }

               if (shouldAdd) {
                 this.props.addMembersAndExitAsync(
                   this.props.selectedGroupId,
                   this.props.currentUserId,
                   this.props.groupRoles,
                   {
                     groupId: group.id,
                     userIds: selectedUsersIds
                   }
                 )
               }

             }}
        >
          <Icon name="plus"/>
          <span>
            {
              translate(TranslateIds.addSelectedUsers)
            }
          </span>
        </div>


      </div>
    )

    const rightArea = (
      <div></div>
    )

    return (
      <CommonHeaderBarContentWrapper leftArea={leftArea} rightArea={rightArea} disabled={this.props.isBusy}/>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(headerBarContent)