/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../../state/reducers/index";
import {Card, Icon, Popup, Checkbox} from "semantic-ui-react";
import {assignGroupRolesToMembers} from "../../../communicationLayer/groupsLayer";
import {
  setMemberGroupRoleAndRefreshAsync,
  setUiIsChangeGroupRolePopupDisplayedAction
} from "../../../state/actions/singleGroupSite/singleGroupSiteActions";
import SelectOptionsList, {SelectableOption} from '../../helpers/selectOptionList'
import {leftIconPopupOffset} from "../../../constants";
import {copyToClipboard} from "../../../helpers/clipboard";
import CardsViewItem from './cardsViewItem'
import {GroupRoleWithPermissionFullBase} from "../../../types/groupRoles";

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
}

const mapStateToProps = (rootState: RootState /*, props: MyProps*/) => {
  return {
    //test0: rootState...
    //test: props.test
    members: rootState.singleGroupState.members,
    groupRoles: rootState.singleGroupState.groupRoles,
    groupId: rootState.singleGroupState.selectedGroupId,
  }
}

const mapDispatchToProps = (dispatch: Dispatch<any>) => bindActionCreators({
  //imported reducer funcs here
  setMemberGroupRoleAndRefreshAsync,
  setUiIsChangeGroupRolePopupDisplayedAction
}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class MemberCardsView extends React.Component<Props, any> {
  render(): JSX.Element {

    const currentUser = this.props.members.find(p => p.isCurrentUser)
    // noinspection TsLint
    let currentUserGroupRole: GroupRoleWithPermissionFullBase = null
    if (currentUser && currentUser.groupRole) {
      currentUserGroupRole = currentUser.groupRole
    }

    return (
      <div>

        <Card.Group>
          {
            this.props.members.map((member, index) => {
              return (
                <CardsViewItem key={member.id} member={member} currentUserGroupRole={currentUserGroupRole}/>
              )
            })
          }
        </Card.Group>

      </div>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(MemberCardsView)