/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../../state/reducers/index";
import SinglePanelSiteWrapper from '../../singlePanelSiteWrapper'
import {Input, Icon} from "semantic-ui-react";
import SystemRolesCardsView from './systemRolesCardsView'
import MaterialSearchInput from '../../material/materialSearchInput'
//const css = require('./styles.styl');
import ChangeSystemRoleDialog from './dialogs/changeSystemRoleDialog'
import {Dimmer, Loader} from "semantic-ui-react";
import Spinner from "../../helpers/Spinner";
import {getSystemRolesAsync} from "../../../state/actions/systemRolesSite/systemRolesCrudActions";
import {loadSystemRolesSite} from "../../../state/actions/systemRolesSite/systemRolesSiteActions";
import {translate} from "../../../../i18n/translationHelper";
import {TranslateIds} from "../../../../i18n/ids";

export interface MyProps {
  //readonly test: string
}

const mapStateToProps = (rootState: RootState /*, props: MyProps*/) => {
  return {
    //test0: rootState...
    //test: props.test
    isChangeDialogDisplayed: rootState.systemRolesState.isChangeDialogDisplayed,
    isLoading: rootState.systemRolesState.isLoading
  }
}

const mapDispatchToProps = (dispatch: Dispatch<any>) => bindActionCreators({
  //imported reducer funcs here,
  loadSystemRolesSite
}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class SystemRolesSite extends React.Component<Props, any> {

  componentWillMount(): void {
    //this is called when we navigate to this site (dialog does not trigger this currently)

    //WHY not use the constructor instead?
    //--> https://github.com/reactjs/react-redux/issues/129
    //seems to throw warnings in some cases... this is the recommended way
    this.props.loadSystemRolesSite()
  }

  render(): JSX.Element {
    return (
      <SinglePanelSiteWrapper>

        {
          this.props.isLoading &&
          <Spinner/>
        }

        {
          !this.props.isChangeDialogDisplayed &&
          <div className="view-padding">
            <div className="view-head-line">
              <div className="view-caption">
                <h1>
                  {
                    translate(TranslateIds.systemRoles)
                  }
                </h1>
              </div>
              <div className="view-options">
                <MaterialSearchInput/>
              </div>
            </div>

            <div className="view-content">
              <SystemRolesCardsView/>
            </div>
          </div>
        }
        {
          !this.props.isLoading && this.props.isChangeDialogDisplayed &&
          <ChangeSystemRoleDialog/>
        }


      </SinglePanelSiteWrapper>

    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(SystemRolesSite)