/**
 * Created by janis dähne.
 */

import * as React from "react";
import {connect} from "react-redux";
import {bindActionCreators, Dispatch} from "redux";
import {returntypeof} from 'react-redux-typescript';
import {RootState} from "../../../state/reducers/index";
import {Icon} from "semantic-ui-react";
import CommonHeaderBarContentWrapper from '../../commonHeaderBarContentWrapper'
import {setViewState} from "../../../state/actions/manageOwnExercisesSite/ownExercisesSiteActions";
import {translate} from "../../../../i18n/translationHelper";
import {TranslateIds} from "../../../../i18n/ids";
import {HelpPopup} from "../../helpers/helpPopup";

//const css = require('./styles.styl');

export interface MyProps {
  //readonly test: string
}

const mapStateToProps = (rootState: RootState /*, props: MyProps*/) => {
  return {
    //test0: rootState...
    //test: props.test
    isLoading: false,
    exerciseRelease: rootState.tutorViewSiteState.exercise.exerciseRelease,
    shouldNotCount: rootState.tutorViewSiteState.userSolution.shouldNotCount
  }
}

const mapDispatchToProps = (dispatch: Dispatch<any>) => bindActionCreators({
  //imported reducer funcs here
  setViewState
}, dispatch)


const stateProps = returntypeof(mapStateToProps);
const dispatchProps = returntypeof(mapDispatchToProps);
type Props = typeof stateProps & typeof dispatchProps;

class HeaderBar extends React.Component<Props, any> {
  render(): JSX.Element {

    const leftArea = (
      <div>

      </div>
    )

    const rightArea = (
      <div className="flexed">
        {
          this.props.shouldNotCount &&
          <div className="flexed">
            <Icon className="mar-right-half" name="flag outline"/>
            <span className="mar-right-half">
                {
                  translate(TranslateIds.shouldNotCount)
                }
              </span>
            <HelpPopup defaultText={translate(TranslateIds.shouldNotCount_helpText_tutor_helpText)}/>
          </div>
        }

      </div>
    )

    return (
      <CommonHeaderBarContentWrapper leftArea={leftArea} rightArea={rightArea} disabled={this.props.isLoading}/>
    )
  }
}

export default connect(mapStateToProps, mapDispatchToProps)(HeaderBar)