/**
 * Created by janis dähne.
 */
import {
  ResetAction, SET_closedExercisesAction, SET_isTagsFilterDisplayedAction, SET_sortByKeyAction, SET_viewStateAction
} from "../../../reducers/allAccessibleExercises/closedExercisesSite/closedExercisesSiteReducer";
import {delay} from "../../../../../debug";
import {
  getClosedExercisePreviews
} from "../../../../communicationLayer/exercisesPreviewLayer";
import {SiteViewState} from "../../../../types/siteView";
import {GET_closedExercisePreviewsAction} from "../../../reducers/allAccessibleExercises/closedExercisesSite/getClosedExercisesReducer";
import {ActionType} from "../../../reducers/allAccessibleExercises/closedExercisesSite/closedExercisesSiteActionTypes";
import {ExercisePreviewFromBackend} from "../../../../types/exercisePreview";
import {SortDirection} from "../../../../types/sortDirection";
import {AwaitActions} from "../../types";
import {loadManageTagsSite} from "../../manageTagsSite/manageTagsActions";
import {resetTagsFilter} from "../../tagsFilterActions";






export function setClosedExercises(closedExercises: ReadonlyArray<ExercisePreviewFromBackend>): SET_closedExercisesAction {
  return {
    type: ActionType.SET_closedExercises,
    closedExercises
  }
}

export function loadClosedExercisePreviewsAsync(): AwaitActions {
  return async(dispatch) => {

    dispatch(resetClosedExercisesSite())

    dispatch(resetTagsFilter())
    await dispatch(loadManageTagsSite())

    await dispatch(getClosedExercisePreviewsAsync())

  }
}

export function getClosedExercisePreviewsAsync(): GET_closedExercisePreviewsAction {
  return {
    type: ActionType.GET_closedExercisePreviews,
    payload: delay(getClosedExercisePreviews())
  }
}

export function setClosedExercisesSiteViewState(viewState: SiteViewState): SET_viewStateAction {
  return {
    type: ActionType.SET_viewState,
    viewState
  }
}


export function setSortByKey(sortByKey: keyof ExercisePreviewFromBackend, sortDirection: SortDirection): SET_sortByKeyAction {
  return {
    type: ActionType.SET_sortByKey,
    sortByKey,
    sortDirection
  }
}

export function setIsTagsFilterDisplayed(isTagsFilterDisplayed: boolean): SET_isTagsFilterDisplayedAction {
  return {
    type: ActionType.SET_isTagsFilterDisplayed,
    isTagsFilterDisplayed,
  }
}


export function resetClosedExercisesSite(): ResetAction {
  return {
    type: ActionType.RESET
  }
}