/**
 * Created by janis dähne.
 */
import {GET_assessmentStatisticsAction} from "../../reducers/assessmentStatisticsSite/getAssessmentStatistics";
import {AwaitActions} from "../types";
import {ActionType} from "../../reducers/assessmentStatisticsSite/assessmentStatisticsSiteActionTypes";
import {delay} from "../../../../debug";
import {getFullAssessmentStatistics} from "../../../communicationLayer/assessmentStatisticsLayer";
import {
  ResetAction, SET_displayNormalTestLineAction, SET_displaySubmitTestLineAction,
  SET_sortByKeyAction
} from "../../reducers/assessmentStatisticsSite/assessmentStatisticsSiteReducer";
import {SingleAssessmentStatistic} from "../../../types/assessmentStatistics";
import {SortDirection} from "../../../types/sortDirection";
import {getPLangsAsync} from "../pLangsActions";




export function setDisplaySubmitTestLine(displaySubmitTestLine: boolean): SET_displaySubmitTestLineAction {
  return {
    type: ActionType.SET_displaySubmitTestLine,
    displaySubmitTestLine,
  }
}

export function setDisplayNormalTestLine(displayNormalTestLine: boolean): SET_displayNormalTestLineAction {
  return {
    type: ActionType.SET_displayNormalTestLine,
    displayNormalTestLine,
  }
}

export function setSortByKey(sortByKey: keyof SingleAssessmentStatistic, sortDirection: SortDirection): SET_sortByKeyAction {
  return {
    type: ActionType.SET_sortByKey,
    sortByKey,
    sortDirection
  }
}



export function getAssessmentStatisticsAsync(targetUserId: number): GET_assessmentStatisticsAction {
  return {
    type: ActionType.GET_assessmentStatistics,
    payload: delay(getFullAssessmentStatistics(targetUserId))
  }
}


export function loadDoExerciseSite(targetUserId: number): AwaitActions {

  return async (dispatch, getState) => {

    dispatch(resetAssessmentStatisticsSite())

    await dispatch(getPLangsAsync())

    await dispatch(getAssessmentStatisticsAsync(targetUserId))

  }
}


export function resetAssessmentStatisticsSite(): ResetAction {
  return {
    type: ActionType.RESET,
  }
}