import {delay} from "../../../../debug";
import {GET_clientServerSettingsAction} from "../../reducers/dashboardSite/crud/getClientServerSettingsReducer";
import {ActionType} from "../../reducers/dashboardSite/dashboardSiteActionTypes";
import {
  getClientServerSettings, getHardwareUsage, getLogicalUsage,
  getTestServerSettings
} from "../../../communicationLayer/dashboardLayer";
import {GET_hardwareUsageAction} from "../../reducers/dashboardSite/crud/getHardwareUsageReducer";
import {GET_logicalUsageAction} from "../../reducers/dashboardSite/crud/getLogicalUsageReducer";
import {GET_testServerSettingsAction} from "../../reducers/dashboardSite/crud/getTestServerSettingsReducer";

/**
 * Created by janis dähne.
 */


export function getHardwareUsageAsync(): GET_hardwareUsageAction {
  return {
    type: ActionType.GET_hardwareUsage,
    payload: delay(getHardwareUsage())
  }
}

export function getLogicalUsageAsync(): GET_logicalUsageAction {
  return {
    type: ActionType.GET_logicalUsage,
    payload: delay(getLogicalUsage())
  }
}

export function getClientServerSettingsAsync(): GET_clientServerSettingsAction {
  return {
    type: ActionType.GET_clientServerSettings,
    payload: delay(getClientServerSettings())
  }
}

export function getTestServerSettingsAsync(): GET_testServerSettingsAction {
  return {
    type: ActionType.GET_testServerSettings,
    payload: delay(getTestServerSettings())
  }
}
