/**
 * Created by janis dähne.
 */
import {RunnableExerciseTestFrontendExclusive} from "../../../../types/exerciseEditor";
import {MultiActions} from "../../types";
import {ActionType} from "../../../reducers/doExerciseSite/doExerciseSiteActionTypes";
import {SET_testsAction} from "../../../reducers/doExerciseSite/doExerciseReducer";
import {SET_afterNormalTestsAction} from "../../../reducers/doExerciseSite/doExerciseSiteReducer";


/**
 * sets the given tests as running and resets there results
 * @param {ReadonlyArray<RunnableExerciseTestFrontendExclusive>} tests
 * @param {ReadonlyArray<RunnableExerciseTestFrontendExclusive>} allTests
 * @returns {MultiActions}
 */
export function setAfterNormalTestsAreRunningAndResetResult(tests: ReadonlyArray<RunnableExerciseTestFrontendExclusive>, allTests: ReadonlyArray<RunnableExerciseTestFrontendExclusive>): MultiActions {
  return dispatch => {

    const copy = allTests.map<RunnableExerciseTestFrontendExclusive>(p => {
      return tests.some(runningTest => p.id === runningTest.id)
        ? {
          ...p,
          uiIsRunning: true,
          result: null
        }
        : p
    })

    dispatch(setAfterNormalTests(copy))
  }
}


export function setAfterNormalTests(afterNormalTests: ReadonlyArray<RunnableExerciseTestFrontendExclusive>): SET_afterNormalTestsAction {
  return {
    type: ActionType.SET_afterNormalTests,
    afterNormalTests
  }
}