/**
 * Created by janis dähne.
 */

import {ActionType} from "../../../reducers/exerciseEditorSite/editorExerciseSiteActionTypes";
import {
  SET_assetsAction,
  SET_editorExerciseContentAction
} from "../../../reducers/exerciseEditorSite/subSets/setEditorExerciseDescriptionReducer";
import {ExerciseAssetFullBase} from "../../../../types/exerciseEditor";
import {MultiActions} from "../../types";
import {createAndRefreshAssetUrlsAndObjects} from "../../../../helpers/assetHelper";

//---ExerciseDescriptionFullBase

export function setDescriptionContent(content: string): SET_editorExerciseContentAction {
  return {
    type: ActionType.SET_editorExerciseContent,
    content
  }
}

/**
 * sets the assets and re creates the object urls (this is better because we use this for adding, removing, loading...)
 * instead to call an additional function on different places
 * @param {ReadonlyArray<ExerciseAssetFullBase>} assets
 * @returns {SET_assetsAction}
 */
export function setExerciseEditorAssets(assets: ReadonlyArray<ExerciseAssetFullBase>):MultiActions  {
  return (dispatch) => {

    dispatch(_setExerciseEditorAssets(assets))

    createAndRefreshAssetUrlsAndObjects(assets)
  }
}


export function _setExerciseEditorAssets(assets: ReadonlyArray<ExerciseAssetFullBase>):SET_assetsAction  {
  return {
    type: ActionType.SET_assets,
    assets
  }
}



