/**
 * Created by janis dähne.
 */
import {SET_idAction, SET_displayNameAction, SET_emailAction} from "../../../reducers/groupsSite/dialog/groupReducer";
import {ActionType} from "../../../reducers/groupsSite/dialog/actionTypes";
import {UserGroupFullBase} from "../../../../types/group";
import {ThunkAction} from "redux-thunk";


export function setTargetGroup(group: UserGroupFullBase): ThunkAction<void, void, void> {
  return (dispatch) => {
    dispatch(setId(group.id))
    dispatch(setDisplayName(group.displayName))
    dispatch(setEmail(group.email))
  }
}


export function setId(id: number): SET_idAction {
  return {
    type: ActionType.SET_id,
    id
  }
}

export function setDisplayName(displayName: string): SET_displayNameAction {
  return {
    type: ActionType.SET_displayName,
    displayName
  }
}

export function setEmail(email: string): SET_emailAction {
  return {
    type: ActionType.SET_email,
    email
  }
}