/**
 * Created by janis dähne.
 */
import {AwaitActions} from "../../types";
import {CREATE_tagAction} from "../../../reducers/manageTagsSite/dialog/createTagReducer";
import {TagFullBase} from "../../../../types/tag";
import {UPDATE_tagAction} from "../../../reducers/manageTagsSite/dialog/updateTagReducer";
import {ActionType} from "../../../reducers/manageTagsSite/dialog/changeTagDialogActionTypes";
import {delay} from "../../../../../debug";
import {update, create} from "../../../../communicationLayer/tagsLayer";
import {getTagsAsync} from '../manageTagsSiteCrudActions'
import {setIsChangeDialogDisplayed} from '../manageTagsActions'
import {resetChangeTagDialog} from './changeTagdialogActions'


export function createTagAsync(tag: TagFullBase): AwaitActions {
  return async (dispatch) => {

    const role = await dispatch(_createTagAsync(tag))
    dispatch(getTagsAsync())
    dispatch(setIsChangeDialogDisplayed(false))
    dispatch(resetChangeTagDialog())

  }
}

function _createTagAsync(tag: TagFullBase): CREATE_tagAction {
  return {
    type: ActionType.CREATE_tag,
    payload: delay(create(tag))
  }
}

export function updateTagAsync(tag: TagFullBase): AwaitActions {
  return async (dispatch) => {
    
    const role = await dispatch(_updateTagAsync(tag))
    dispatch(getTagsAsync())
    dispatch(setIsChangeDialogDisplayed(false))
    dispatch(resetChangeTagDialog())
  }
}

function _updateTagAsync(tag: TagFullBase): UPDATE_tagAction {
  return {
    type: ActionType.UPDATE_tag,
    payload: delay(update(tag))
  }
}