/**
 * Created by janis dähne.
 */
import {
  ResetAction, SET_isChangeDialogDisplayedAction, SET_tagsAction
} from "../../reducers/manageTagsSite/manageTagsSiteReducer";
import {TagFullBase} from "../../../types/tag";
import {ThunkAction} from "redux-thunk";
import {resetChangeTagDialog, setIsCreating} from './dialog/changeTagdialogActions'
import {ActionType} from "../../reducers/manageTagsSite/manageTagsSiteActionTypes";
import {setTargetTag} from "./dialog/tagSetActions";
import {AwaitActions} from "../types";
import {getTagsAsync} from "./manageTagsSiteCrudActions";


export function setTags(tags: ReadonlyArray<TagFullBase>): SET_tagsAction {
  return {
    type: ActionType.SET_tags,
    tags
  }
}

export function openCreateTagDialog(): ThunkAction<void, void, void> {
  return dispatch => {

    dispatch(resetChangeTagDialog())
    dispatch(setIsCreating(true))
    dispatch(setIsChangeDialogDisplayed(true))
  }
}

export function openEditTagDialog(systemRole: TagFullBase): ThunkAction<void, void, void> {
  return dispatch => {

    dispatch(resetChangeTagDialog())
    dispatch(setIsCreating(false))
    dispatch(setTargetTag(systemRole))
    dispatch(setIsChangeDialogDisplayed(true))

  }
}

export function cancelEditTag(): ThunkAction<void, void, void> {
  return dispatch => {

    dispatch(setIsChangeDialogDisplayed(false))
    dispatch(resetChangeTagDialog())

  }
}


export function setIsChangeDialogDisplayed(isDisplayed: boolean): SET_isChangeDialogDisplayedAction {
  return {
    type: ActionType.SET_isChangeDialogDisplayed,
    isDisplayed
  }
}

export function loadManageTagsSite(): AwaitActions {
  return async (dispatch, getState) => {

    dispatch(resetManageTagsSite())

    await dispatch(getTagsAsync())

  }
}

export function resetManageTagsSite(): ResetAction {
  return {
    type: ActionType.RESET
  }
}