/**
 * Created by janis dähne.
 */
import {createExerciseRelease, updateExerciseRelease} from "../../../../../../communicationLayer/exerciseReleasesLayer";
import {ExerciseReleaseForBackend} from "../../../../../../types/exerciseRelease";
import {setIsChangeDialogDisplayedAction} from "../../exerciseReleasesSiteActions";
import {resetChangeExerciseReleaseDialog} from "./changeExerciseReleaseDialogActions";
import {getExerciseReleaseAsync} from "../../getReleasesSiteCrudAction";
import {delay} from "../../../../../../../debug";
import {AwaitActions} from "../../../../types";
import {CREATE_exerciseReleaseAction} from "../../../../../reducers/ownOrGroupExerciseReducers/exerciseReleasesSite/dialogs/changeExerciseReleaseDialog/createExerciseReleaseReducer";
import {ActionType} from "../../../../../reducers/ownOrGroupExerciseReducers/exerciseReleasesSite/dialogs/changeExerciseReleaseDialog/changeExerciseReleaseDialogActionTypes";
import {UPDATE_exerciseReleaseAction} from "../../../../../reducers/ownOrGroupExerciseReducers/exerciseReleasesSite/dialogs/changeExerciseReleaseDialog/updateExerciseReleaseReducer";


export function createExerciseReleaseAsync(forExerciseId: number, release: ExerciseReleaseForBackend): AwaitActions {
  return async (dispatch) => {


    await dispatch(_createExerciseReleaseAsync(forExerciseId, release))

    dispatch(getExerciseReleaseAsync(forExerciseId))
    dispatch(setIsChangeDialogDisplayedAction(false))
    dispatch(resetChangeExerciseReleaseDialog())

  }
}

function _createExerciseReleaseAsync(forExerciseId: number, release: ExerciseReleaseForBackend): CREATE_exerciseReleaseAction {
  return {
    type: ActionType.CREATE_exerciseRelease,
    payload: delay(createExerciseRelease({
      forExerciseId,
      release
    }))
  }
}


export function updateExerciseReleaseAsync(exerciseId: number, release: ExerciseReleaseForBackend): AwaitActions {
  return async (dispatch, getState) => {

    await dispatch(_updateExerciseReleaseAsync(release))

    dispatch(getExerciseReleaseAsync(exerciseId))
    dispatch(setIsChangeDialogDisplayedAction(false))
    dispatch(resetChangeExerciseReleaseDialog())
  }
}


function _updateExerciseReleaseAsync(release: ExerciseReleaseForBackend): UPDATE_exerciseReleaseAction {
  return {
    type: ActionType.UPDATE_exerciseRelease,
    payload: delay(updateExerciseRelease(release))
  }
}