/**
 * Created by janis dähne.
 */
import {ActionType} from "../../../../../reducers/ownOrGroupExerciseReducers/exerciseReleasesSite/dialogs/changeExerciseReleaseDialog/changeExerciseReleaseDialogActionTypes";
import {
  SET_automaticEndAtAction,
  SET_automaticStartAtAction, SET_availableWorkingTimeInMinutesAction, SET_exerciseReleaseIdAction,
  SET_generatedCodeAction, SET_hasLimitedWorkingTimeAction, SET_hideInOverviewsAction, SET_hideSiteHeaderBarAction,
  SET_isReleasedAction, SET_isVisibleToAllAfterReleaseAction, SET_noteAction, SET_pLangIdAction,
  SET_releaseDurationTypeAction, SET_releaseStartTypeAction,
  SET_runAlsoNormalTestsAction,
  SET_shouldAutomaticAssessSubmissionsAction, SET_shouldClearClipboardAction
} from "../../../../../reducers/ownOrGroupExerciseReducers/exerciseReleasesSite/dialogs/changeExerciseReleaseDialog/setExerciseReleaseReducer";
import {Moment} from "moment";
import {ExerciseReleaseFromBackend} from "../../../../../../types/exerciseRelease";
import {MultiActions} from "../../../../types";
import {ReleaseDurationType} from "../../../../../../types/ReleaseDurationType";
import {ReleaseStartType} from "../../../../../../types/ReleaseStartType";


export function setId(exerciseReleaseId: number): SET_exerciseReleaseIdAction {
  return {
    type: ActionType.SET_exerciseReleaseId,
    id: exerciseReleaseId
  }
}

export function setIsReleased(isReleased: boolean): SET_isReleasedAction {
  return {
    type: ActionType.SET_isReleased,
    isReleased
  }
}
export function setGeneratedCode(generatedCode: string): SET_generatedCodeAction {
  return {
    type: ActionType.SET_generatedCode,
    generatedCode
  }
}

export function setPLangId(pLangId: number | null): SET_pLangIdAction {
  return {
    type: ActionType.SET_pLangId,
    pLangId
  }
}

export function setAutomaticStartAt(automaticStartAt: Moment | null): SET_automaticStartAtAction {
  return {
    type: ActionType.SET_automaticStartAt,
    automaticStartAt
  }
}

export function setAutomaticEndAt(automaticEndAt: Moment | null): SET_automaticEndAtAction {
  return {
    type: ActionType.SET_automaticEndAt,
    automaticEndAt
  }
}


export function setHasLimitedWorkingTime(hasLimitedWorkingTime: boolean): SET_hasLimitedWorkingTimeAction {
  return {
    type: ActionType.SET_hasLimitedWorkingTime,
    hasLimitedWorkingTime
  }
}

export function setAvailableWorkingTimeInMinutes(availableWorkingTimeInMinutes: number | null): SET_availableWorkingTimeInMinutesAction {
  return {
    type: ActionType.SET_availableWorkingTimeInMinutes,
    availableWorkingTimeInMinutes
  }
}

export function setNote(note: string): SET_noteAction {
  return {
    type: ActionType.SET_note,
    note
  }
}

export function setIsVisibleToAllAfterRelease(isVisibleToAllAfterRelease: boolean): SET_isVisibleToAllAfterReleaseAction {
  return {
    type: ActionType.SET_isVisibleToAllAfterRelease,
    isVisibleToAllAfterRelease
  }
}

export function setShouldAutomaticAssessSubmissions(shouldAutomaticAssessSubmissions: boolean): SET_shouldAutomaticAssessSubmissionsAction {
  return {
    type: ActionType.SET_shouldAutomaticAssessSubmissions,
    shouldAutomaticAssessSubmissions
  }
}

export function setRunAlsoNormalTests(runAlsoNormalTests: boolean): SET_runAlsoNormalTestsAction {
  return {
    type: ActionType.SET_runAlsoNormalTests,
    runAlsoNormalTests
  }
}

export function setReleaseDurationType(releaseDurationType: ReleaseDurationType): SET_releaseDurationTypeAction {
  return {
    type: ActionType.SET_releaseDurationType,
    releaseDurationType
  }
}

export function setReleaseStartType(releaseStartType: ReleaseStartType): SET_releaseStartTypeAction {
  return {
    type: ActionType.SET_releaseStartType,
    releaseStartType
  }
}


export function setHideInOverviews(hideInOverviews: boolean): SET_hideInOverviewsAction {
  return {
    type: ActionType.SET_hideInOverviews,
    hideInOverviews
  }
}

export function setShouldClearClipboard(shouldClearClipboard: boolean): SET_shouldClearClipboardAction {
  return {
    type: ActionType.SET_shouldClearClipboard,
    shouldClearClipboard
  }
}

export function setHideSiteHeaderBar(hideSiteHeaderBar: boolean): SET_hideSiteHeaderBarAction {
  return {
    type: ActionType.SET_hideSiteHeaderBar,
    hideSiteHeaderBar
  }
}

