/**
 * Created by janis dähne.
 */
import {RERUN_automaticAssessmentAction} from "../../../reducers/ownOrGroupExerciseReducers/submissionsSite/rerunAutomaticAssessmentReducer";
import {ActionType} from "../../../reducers/ownOrGroupExerciseReducers/submissionsSite/submissionsSiteActionTypes";
import {delay} from "../../../../../debug";
import {
  getFromRelease, rerunAutomaticAssessment,
  rerunSingleAutomaticAssessment
} from "../../../../communicationLayer/submissionsLayer";
import {RERUN_singleAutomaticAssessmentAction} from "../../../reducers/ownOrGroupExerciseReducers/submissionsSite/rerunSingleAutomaticAssessmentReducer";
import {GET_submissionsAction} from "../../../reducers/ownOrGroupExerciseReducers/submissionsSite/getSubmissionsReducer";


export function _rerunAutomaticAssessmentActionAsync(releaseCode: string): RERUN_automaticAssessmentAction {
  return {
    type: ActionType.RERUN_automaticAssessment,
    payload: delay(rerunAutomaticAssessment(releaseCode))
  }
}


export function _rerunSingleAutomaticAssessmentActionAsync(releaseCode: string, userId: number, pLangId: number): RERUN_singleAutomaticAssessmentAction {
  return {
    type: ActionType.RERUN_singleAutomaticAssessment,
    payload: delay(rerunSingleAutomaticAssessment(releaseCode, userId, pLangId))
  }
}

export function getSubmissions(releaseCode: string): GET_submissionsAction {
  return {
    type: ActionType.GET_submissions,
    payload: delay(getFromRelease(releaseCode))
  }
}