/**
 * Created by janis dähne.
 */
import {ActionType} from "../../reducers/singleGroupSite/singleGroupSiteActionTypes";
import {delay} from "../../../../debug";
import {getGroupRoles} from "../../../communicationLayer/groupRolesLayer";
import {GroupRoleWithPermissionFullBase} from "../../../types/groupRoles";
import {GET_membersAction} from "../../reducers/singleGroupSite/getSingleGroupReducer";
import {
  changeMemberRole, deleteUserGroup, getGroups, getMembers,
  removeMember
} from "../../../communicationLayer/groupsLayer";
import {SET_memberGroupRoleAction} from "../../reducers/singleGroupSite/setMemberGroupRoleReducer";
import {REMOVE_memberAction} from "../../reducers/singleGroupSite/removeMemberReducer";
import {DELETE_userGroupAction} from "../../reducers/groupsSite/deleteGroupReducer";
import {AwaitActions} from "../types";
import {loadSingleGroupSite} from "./singleGroupSiteActions";



//normally we should do 1 request and get members + roles + group data ...
export function getMembersAsync(groupId: number, currentUserId: number, groupRoles: ReadonlyArray<GroupRoleWithPermissionFullBase>): GET_membersAction {
  return {
    type: ActionType.GET_members,
    payload: delay(getMembers(groupId)),
    meta: {
      groupRoles,
      currentUserId
    }
  }
}


export function removeMemberAsync(userId: number, groupId: number): REMOVE_memberAction {
  return {
    type: ActionType.REMOVE_member,
    payload: delay(removeMember({
      userId,
      groupId,
      useCurrentUser: false //in the singe group view the user cannot remove him/herself
    })),
  }
}

export function setMemberGroupRoleAsync(userId: number, groupId: number, groupRoleId: number, shouldHideLoading: boolean): SET_memberGroupRoleAction {
  return {
    type: ActionType.SET_memberGroupRole,
    payload: delay(changeMemberRole({
      userId,
      groupId,
      groupRoleId
    })),
    meta: {
      shouldHideLoading: shouldHideLoading
    }
  }
}

