/**
 * Created by janis dähne.
 */
import {ActionBase, ActionType} from "../dashboardSiteActionTypes";
import {initial, State} from "../dashboardSiteReducer";
import {ReduxPromiseAction, ReduxPromiseFulfilledAction, ReduxPromiseRejectedAction} from "../../index";
import {notExhaustive} from "../../_notExhausiveHelper";
import {ClientServerSettings} from "../../../../types/dashboard";



export interface GET_clientServerSettingsAction
  extends ActionBase, ReduxPromiseAction<ClientServerSettings, GET_clientServerSettings_PENDINGAction, GET_clientServerSettings_FULFILLEDAction, GET_clientServerSettings_REJECTEDAction> {
  readonly type: ActionType.GET_clientServerSettings
  readonly payload: Promise<ClientServerSettings>
}

//automatically dispatched by redux promise middleware
export interface GET_clientServerSettings_PENDINGAction
  extends ActionBase {
  readonly type: ActionType.GET_clientServerSettings_PENDING
}

//automatically dispatched by redux promise middleware
export interface GET_clientServerSettings_FULFILLEDAction
  extends ActionBase, ReduxPromiseFulfilledAction<ClientServerSettings> {
  readonly type: ActionType.GET_clientServerSettings_FULFILLED
  readonly payload: ClientServerSettings
}

//automatically dispatched by redux promise middleware
export interface GET_clientServerSettings_REJECTEDAction
  extends ActionBase, ReduxPromiseRejectedAction<void> {
  readonly type: ActionType.GET_clientServerSettings_REJECTED
  readonly payload: any
}


export type AllActions =
  GET_clientServerSettings_PENDINGAction
  | GET_clientServerSettings_FULFILLEDAction
  | GET_clientServerSettings_REJECTEDAction


export function reducer(state: State = initial, action: AllActions): State {

  switch (action.type) {

    case ActionType.GET_clientServerSettings_PENDING:
      return {
        ...state,
        isLoading: true
      }
    case ActionType.GET_clientServerSettings_FULFILLED:
      return {
        ...state,
        isLoading: false,
        clientServerSettings: action.payload
      }
    case ActionType.GET_clientServerSettings_REJECTED:
      return {
        ...state,
        isLoading: false,
        clientServerSettings: initial.clientServerSettings
      }

    default:
      notExhaustive(action)
      return state
  }
}

