/**
 * Created by janis dähne.
 */

import {ActionBase, ActionType} from "../editCustomProjectSiteActionTypes";
import {State, initial} from "../editCustomProjectSiteReducer";
import {ReduxPromiseAction, ReduxPromiseFulfilledAction, ReduxPromiseRejectedAction} from "../../index";
import {notExhaustive} from "../../_notExhausiveHelper";

export interface DELETE_customProjectTestAction
  extends ActionBase, ReduxPromiseAction<void, DELETE_customProjectTest_PENDINGAction, DELETE_customProjectTest_FULFILLEDAction, DELETE_customProjectTest_REJECTEDAction> {
  readonly type: ActionType.DELETE_customProjectTest
  readonly payload: Promise<void>
}

//automatically dispatched by redux promise middleware
export interface DELETE_customProjectTest_PENDINGAction
  extends ActionBase {
  readonly type: ActionType.DELETE_customProjectTest_PENDING
}

//automatically dispatched by redux promise middleware
export interface DELETE_customProjectTest_FULFILLEDAction
  extends ActionBase, ReduxPromiseFulfilledAction<void> {
  readonly type: ActionType.DELETE_customProjectTest_FULFILLED
  readonly payload: void
}

//automatically dispatched by redux promise middleware
export interface DELETE_customProjectTest_REJECTEDAction
  extends ActionBase, ReduxPromiseRejectedAction<void> {
  readonly type: ActionType.DELETE_customProjectTest_REJECTED
  readonly payload: any
}


export type AllActions =
  DELETE_customProjectTest_PENDINGAction
  | DELETE_customProjectTest_FULFILLEDAction
  | DELETE_customProjectTest_REJECTEDAction


export function reducer(state: State = initial, action: AllActions): State {

  switch (action.type) {

    case ActionType.DELETE_customProjectTest_PENDING:
      return {
        ...state,
        isLoading: true
      }
    case ActionType.DELETE_customProjectTest_FULFILLED:
      return {
        ...state,
        isLoading: false
      }
    case ActionType.DELETE_customProjectTest_REJECTED:
      return {
        ...state,
        isLoading: false
      }

    default:
      notExhaustive(action)
      return state
  }
}

