/**
 * Created by janis dähne.
 */

import {ActionBase, ActionType} from "../editCustomProjectSiteActionTypes";
import {initial, State} from "../editCustomProjectSiteReducer";
import {CustomProjectSolutionFullBase} from "../../../../types/customProjects";
import {ReduxPromiseAction, ReduxPromiseFulfilledAction, ReduxPromiseRejectedAction} from "../../index";
import {notExhaustive} from "../../_notExhausiveHelper";

export interface UPDATE_customProjectSolutionAction
  extends ActionBase, ReduxPromiseAction<CustomProjectSolutionFullBase, UPDATE_customProjectSolution_PENDINGAction, UPDATE_customProjectSolution_FULFILLEDAction, UPDATE_customProjectSolution_REJECTEDAction> {
  readonly type: ActionType.UPDATE_customProjectSolution
  readonly payload: Promise<CustomProjectSolutionFullBase>
}

//automatically dispatched by redux promise middleware
export interface UPDATE_customProjectSolution_PENDINGAction
  extends ActionBase {
  readonly type: ActionType.UPDATE_customProjectSolution_PENDING
}

//automatically dispatched by redux promise middleware
export interface UPDATE_customProjectSolution_FULFILLEDAction
  extends ActionBase, ReduxPromiseFulfilledAction<CustomProjectSolutionFullBase> {
  readonly type: ActionType.UPDATE_customProjectSolution_FULFILLED
  readonly payload: CustomProjectSolutionFullBase
}

//automatically dispatched by redux promise middleware
export interface UPDATE_customProjectSolution_REJECTEDAction
  extends ActionBase, ReduxPromiseRejectedAction<void> {
  readonly type: ActionType.UPDATE_customProjectSolution_REJECTED
  readonly payload: any
}


export type AllActions =
  UPDATE_customProjectSolution_PENDINGAction
  | UPDATE_customProjectSolution_FULFILLEDAction
  | UPDATE_customProjectSolution_REJECTEDAction


export function reducer(state: State = initial, action: AllActions): State {

  switch (action.type) {

    case ActionType.UPDATE_customProjectSolution_PENDING:
      return {
        ...state,
        isLoading: true
      }
    case ActionType.UPDATE_customProjectSolution_FULFILLED:
      return {
        ...state,
        isLoading: false,
        initialSolutionFromBackend: {
          ...action.payload
        }
      }
    case ActionType.UPDATE_customProjectSolution_REJECTED:
      return {
        ...state,
        isLoading: false
      }

    default:
      notExhaustive(action)
      return state
  }
}

