/**
 * Created by janis dähne.
 */
import {ActionBase, ActionType} from "./changeCustomProjectTestDialogActionTypes";
import {State,initial} from "./changeCustomProjectTestDialogReducer";
import {ReduxPromiseAction, ReduxPromiseFulfilledAction, ReduxPromiseRejectedAction} from "../../../index";
import {CustomProjectTestFullBase} from "../../../../../types/customProjects";
import {notExhaustive} from "../../../_notExhausiveHelper";
import {convertCustomProjectTestFromBackendToRunnableFrontendCustomProjectTest} from "../../../../../helpers/convertersAndTransformers";


export interface UPDATE_customProjectReducerAction
  extends ActionBase, ReduxPromiseAction<CustomProjectTestFullBase, UPDATE_customProjectReducer_PENDINGAction, UPDATE_customProjectReducer_FULFILLEDAction, UPDATE_customProjectReducer_REJECTEDAction> {
  readonly type: ActionType.UPDATE_customProjectReducer
  readonly payload: Promise<CustomProjectTestFullBase>
}

//automatically dispatched by redux promise middleware
export interface UPDATE_customProjectReducer_PENDINGAction
  extends ActionBase {
  readonly type: ActionType.UPDATE_customProjectReducer_PENDING
}

//automatically dispatched by redux promise middleware
export interface UPDATE_customProjectReducer_FULFILLEDAction
  extends ActionBase, ReduxPromiseFulfilledAction<CustomProjectTestFullBase> {
  readonly type: ActionType.UPDATE_customProjectReducer_FULFILLED
  readonly payload: CustomProjectTestFullBase
}

//automatically dispatched by redux promise middleware
export interface UPDATE_customProjectReducer_REJECTEDAction
  extends ActionBase, ReduxPromiseRejectedAction<void> {
  readonly type: ActionType.UPDATE_customProjectReducer_REJECTED
  readonly payload: any
}


export type AllActions =
  UPDATE_customProjectReducer_PENDINGAction
  | UPDATE_customProjectReducer_FULFILLEDAction
  | UPDATE_customProjectReducer_REJECTEDAction


export function reducer(state: State = initial(), action: AllActions): State {

  switch (action.type) {

    case ActionType.UPDATE_customProjectReducer_PENDING:
      return {
        ...state,
        isBusy: true
      }
    case ActionType.UPDATE_customProjectReducer_FULFILLED:
      return {
        ...state,
        isBusy: false,
        test: convertCustomProjectTestFromBackendToRunnableFrontendCustomProjectTest(action.payload)
      }
    case ActionType.UPDATE_customProjectReducer_REJECTED:
      return {
        ...state,
        isBusy: false
      }

    default:
      notExhaustive(action)
      return state
  }
}

