/**
 * Created by janis dähne.
 */
import {notExhaustive} from "../../_notExhausiveHelper";
import {
  EditorExercisePropertiesFullBase, ExerciseAssetFullBase,
  ExerciseDescriptionFullBase
} from "../../../../types/exerciseEditor";
import {ActionBase, ActionType} from "../editorExerciseSiteActionTypes";
import {getNextFrontendId} from "../../../../helpers/frontendIdHelper";


export type State = ExerciseDescriptionFullBase


export const initial: () => State = () => {
  return {
    id: getNextFrontendId(),
    content:
`[question=md]

...`,
    assets: []
  }
}

export interface SET_editorExerciseDescriptionIdAction extends ActionBase {
  readonly type: ActionType.SET_editorExerciseDescriptionId
  readonly id: number
}

export interface SET_editorExerciseContentAction extends ActionBase {
  readonly type: ActionType.SET_editorExerciseContent
  readonly content: string
}

export interface SET_assetsAction extends ActionBase {
  readonly type: ActionType.SET_assets
  readonly assets: ReadonlyArray<ExerciseAssetFullBase>
}

export type AllActions =
  SET_editorExerciseDescriptionIdAction
  | SET_editorExerciseContentAction
  | SET_assetsAction


export function reducer(state: State = initial(), action: AllActions): State {

  switch (action.type) {


    case ActionType.SET_editorExerciseDescriptionId:
      return {
        ...state,
        id: action.id
      }

    case ActionType.SET_editorExerciseContent:
      return {
        ...state,
        content: action.content
      }

    case ActionType.SET_assets:
      return {
        ...state,
        assets: action.assets
      }


    default:
      notExhaustive(action)
      return state
  }
}

