/**
 * Created by janis dähne.
 */
import {notExhaustive} from "../_notExhausiveHelper";
import {ReduxPromiseAction, ReduxPromiseFulfilledAction, ReduxPromiseRejectedAction} from "../index";
import {ActionBase, ActionType} from "./groupsSiteActionTypes";
import {initial, State} from "./groupsSiteReducer";
import Logger from "../../../helpers/logger";

export interface DELETE_userGroupAction
  extends ActionBase, ReduxPromiseAction<void, DELETE_userGroup_PENDINGAction, DELETE_userGroup_FULFILLEDAction, DELETE_userGroup_REJECTEDAction> {
  readonly type: ActionType.DELETE_userGroup
  readonly payload: Promise<void>
}

//automatically dispatched by redux promise middleware
export interface DELETE_userGroup_PENDINGAction
  extends ActionBase {
  readonly type: ActionType.DELETE_userGroup_PENDING
}

//automatically dispatched by redux promise middleware
export interface DELETE_userGroup_FULFILLEDAction
  extends ActionBase, ReduxPromiseFulfilledAction<void> {
  readonly type: ActionType.DELETE_userGroup_FULFILLED
  readonly payload: void
}

//automatically dispatched by redux promise middleware
export interface DELETE_userGroup_REJECTEDAction
  extends ActionBase, ReduxPromiseRejectedAction<void> {
  readonly type: ActionType.DELETE_userGroup_REJECTED
  readonly payload: any
}


export type AllActions =
  DELETE_userGroup_PENDINGAction
  | DELETE_userGroup_FULFILLEDAction
  | DELETE_userGroup_REJECTEDAction


export function reducer(state: State = initial, action: AllActions): State {

  switch (action.type) {

    case ActionType.DELETE_userGroup_PENDING:
      return {
        ...state,
        isLoading: true
      }
    case ActionType.DELETE_userGroup_FULFILLED:
      return {
        ...state,
        isLoading: false, //then reload
      }
    case ActionType.DELETE_userGroup_REJECTED:
      return {
        ...state,
        isLoading: false
      }

    default:
      notExhaustive(action)
      return state
  }
}

