/**
 * Created by janis dähne.
 */
import {Action} from "redux";
import {notExhaustive} from "../../_notExhausiveHelper";
import {ReduxPromiseAction, ReduxPromiseFulfilledAction, ReduxPromiseRejectedAction} from "../../index";
import {ActionBase, ActionType} from "./changeActivatedUserDataDialogActionTypes";
import {State, initial} from "./changeActivatedUserDataDialogReducer";
import Logger from "../../../../helpers/logger";


export interface UPDATE_activatedUserDataAction
  extends ActionBase, ReduxPromiseAction<void, UPDATE_activatedUserData_PENDINGAction, UPDATE_activatedUserData_FULFILLEDAction, UPDATE_activatedUserData_REJECTEDAction> {
  readonly type: ActionType.UPDATE_activatedUserData
  readonly payload: Promise<void>
}

//automatically dispatched by redux promise middleware
export interface UPDATE_activatedUserData_PENDINGAction
  extends ActionBase {
  readonly type: ActionType.UPDATE_activatedUserData_PENDING
}

//automatically dispatched by redux promise middleware
export interface UPDATE_activatedUserData_FULFILLEDAction
  extends ActionBase, ReduxPromiseFulfilledAction<void> {
  readonly type: ActionType.UPDATE_activatedUserData_FULFILLED
  readonly payload: void
}

//automatically dispatched by redux promise middleware
export interface UPDATE_activatedUserData_REJECTEDAction
  extends ActionBase, ReduxPromiseRejectedAction<void> {
  readonly type: ActionType.UPDATE_activatedUserData_REJECTED
  readonly payload: any
}


export type AllActions =
  UPDATE_activatedUserData_PENDINGAction
  | UPDATE_activatedUserData_FULFILLEDAction
  | UPDATE_activatedUserData_REJECTEDAction


export function reducer(state: State = initial, action: AllActions): State {


  switch (action.type) {

    case ActionType.UPDATE_activatedUserData_PENDING:
      return {
        ...state,
        isBusy: true
      }
    case ActionType.UPDATE_activatedUserData_FULFILLED:
      return {
        ...state,
        //isBusy: false //do not stop loading because we already (currently) change user data + system role, see src/state/actions/manageActivatedUsersSite/dialogs/changeActivatedUserDataCrudActions.ts
      }
    case ActionType.UPDATE_activatedUserData_REJECTED:
      return {
        ...state,
        //isBusy: false //do not stop loading because we already (currently) change user data + system role , see src/state/actions/manageActivatedUsersSite/dialogs/changeActivatedUserDataCrudActions.ts
      }

    default:
      notExhaustive(action)
      return state
  }
}

