/**
 * Created by janis dähne.
 */

import {notExhaustive} from "../../_notExhausiveHelper";
import {ReduxPromiseAction, ReduxPromiseFulfilledAction, ReduxPromiseRejectedAction} from "../../index";
import {ActionType, ActionBase} from './changeTagDialogActionTypes'
import {TagFullBase} from "../../../../types/tag";
import {initial, State} from "./changeTagDialogReducer";


export interface CREATE_tagAction
  extends ActionBase, ReduxPromiseAction<TagFullBase, CREATE_tag_PENDINGAction, CREATE_tag_FULFILLEDAction, CREATE_tag_REJECTEDAction> {
  readonly type: ActionType.CREATE_tag
  readonly payload: Promise<TagFullBase>
}

//automatically dispatched by redux promise middleware
export interface CREATE_tag_PENDINGAction
  extends ActionBase {
  readonly type: ActionType.CREATE_tag_PENDING
}

//automatically dispatched by redux promise middleware
export interface CREATE_tag_FULFILLEDAction
  extends ActionBase, ReduxPromiseFulfilledAction<TagFullBase> {
  readonly type: ActionType.CREATE_tag_FULFILLED
  readonly payload: TagFullBase
}

//automatically dispatched by redux promise middleware
export interface CREATE_tag_REJECTEDAction
  extends ActionBase, ReduxPromiseRejectedAction<TagFullBase> {
  readonly type: ActionType.CREATE_tag_REJECTED
  readonly payload: any
}


export type AllActions =
  CREATE_tag_PENDINGAction
  | CREATE_tag_FULFILLEDAction
  | CREATE_tag_REJECTEDAction


export function reducer(state: State = initial, action: AllActions): State {

  switch (action.type) {

    case ActionType.CREATE_tag_PENDING:
      return {
        ...state,
        isBusy: true
      }
    case ActionType.CREATE_tag_FULFILLED:
      return {
        ...state,
        isBusy: false
      }
    case ActionType.CREATE_tag_REJECTED:
      return {
        ...state,
        isBusy: false
      }

    default:
      notExhaustive(action)
      return state
  }
}


