/**
 * Created by janis dähne.
 */
import {notExhaustive} from "../../_notExhausiveHelper";
import {initial, State} from "./releaseSiteReducer";
import Logger from "../../../../helpers/logger";
import {
  GET_groupExercises_FULFILLEDAction,
  GET_groupExercises_PENDINGAction, GET_groupExercises_REJECTEDAction
} from "../../manageGroupExercisesSite/getGroupExercisesReducer";
import {ActionType} from "../../manageGroupExercisesSite/groupExercisesSiteActionTypes";



export type AllActions =
  GET_groupExercises_PENDINGAction
  | GET_groupExercises_FULFILLEDAction
  | GET_groupExercises_REJECTEDAction


export function reducer(state: State = initial, action: AllActions): State {

  switch (action.type) {

    case ActionType.GET_groupExercises_PENDING:
      return {
        ...state,
        isLoading: true
      }
    case ActionType.GET_groupExercises_FULFILLED:
      return {
        ...state,
        isLoading: false,
        exercises: action.payload.map(p => p.exercisePreviews).reduce((prev, curr) => [...prev, ...curr], [])
      }
    case ActionType.GET_groupExercises_REJECTED:
      return {
        ...state,
        isLoading: false,
        exercises: []
      }

    default:
      notExhaustive(action)
      return state
  }
}

