/**
 * Created by janis dähne.
 */

import {AllActions as GetReleasesActions} from '../exerciseReleasesSite/getReleasesReducer'
import {initial, State} from "./submissionsSiteReducer";
import {ActionType} from "../exerciseReleasesSite/releasesSiteActionTypes";
import Logger from "../../../../helpers/logger";
import {notExhaustive} from "../../_notExhausiveHelper";

export type AllActions =
  GetReleasesActions


export function reducer(state: State = initial, action: AllActions): State {


  switch (action.type) {

    case ActionType.GET_exerciseReleases_PENDING:
      return {
        ...state,
        isLoading: true
      }
    case ActionType.GET_exerciseReleases_FULFILLED:
      return {
        ...state,
        isLoading: false,
        releases: action.payload
      }
    case ActionType.GET_exerciseReleases_REJECTED:
      return {
        ...state,
        isLoading: false,
        releases: []
      }

    default:
      notExhaustive(action)
      return state
  }
}

