/**
 * Created by janis dähne.
 */
import {notExhaustive} from "../../_notExhausiveHelper";
import {ReduxPromiseAction, ReduxPromiseFulfilledAction, ReduxPromiseRejectedAction} from "../../index";
import {ActionBase, ActionType} from "./submissionsSiteActionTypes";
import {initial, State} from "./submissionsSiteReducer";
import Logger from "../../../../helpers/logger";
export interface RERUN_singleAutomaticAssessmentAction
  extends ActionBase, ReduxPromiseAction<boolean, RERUN_singleAutomaticAssessment_PENDINGAction, RERUN_singleAutomaticAssessment_FULFILLEDAction, RERUN_singleAutomaticAssessment_REJECTEDAction> {
  readonly type: ActionType.RERUN_singleAutomaticAssessment
  readonly payload: Promise<boolean>
}

//automatically dispatched by redux promise middleware
export interface RERUN_singleAutomaticAssessment_PENDINGAction
  extends ActionBase {
  readonly type: ActionType.RERUN_singleAutomaticAssessment_PENDING
}

//automatically dispatched by redux promise middleware
export interface RERUN_singleAutomaticAssessment_FULFILLEDAction
  extends ActionBase, ReduxPromiseFulfilledAction<boolean> {
  readonly type: ActionType.RERUN_singleAutomaticAssessment_FULFILLED
  readonly payload: boolean
}

//automatically dispatched by redux promise middleware
export interface RERUN_singleAutomaticAssessment_REJECTEDAction
  extends ActionBase, ReduxPromiseRejectedAction<void> {
  readonly type: ActionType.RERUN_singleAutomaticAssessment_REJECTED
  readonly payload: any
}


export type AllActions =
  RERUN_singleAutomaticAssessment_PENDINGAction
  | RERUN_singleAutomaticAssessment_FULFILLEDAction
  | RERUN_singleAutomaticAssessment_REJECTEDAction


export function reducer(state: State = initial, action: AllActions): State {

  switch (action.type) {

    case ActionType.RERUN_singleAutomaticAssessment_PENDING:
      return {
        ...state,
        isLoading: true
      }
    case ActionType.RERUN_singleAutomaticAssessment_FULFILLED:
      return {
        ...state,
        isLoading: false
      }
    case ActionType.RERUN_singleAutomaticAssessment_REJECTED:
      return {
        ...state,
        isLoading: false
      }

    default:
      notExhaustive(action)
      return state
  }
}

