/**
 * Created by janis dähne.
 */
import {notExhaustive} from "../../../_notExhausiveHelper";
import {ReduxPromiseAction, ReduxPromiseFulfilledAction, ReduxPromiseRejectedAction} from "../../../index";
import {ActionBase, ActionType} from "./addsUserDialogActionTypes";
import {initial, State} from "./addUsersDialogReducer";
import Logger from "../../../../../helpers/logger";



export interface ADD_membersAction
  extends ActionBase, ReduxPromiseAction<void, ADD_members_PENDINGAction, ADD_members_FULFILLEDAction, ADD_members_REJECTEDAction> {
  readonly type: ActionType.ADD_members
  readonly payload: Promise<void>
}

//automatically dispatched by redux promise middleware
export interface ADD_members_PENDINGAction
  extends ActionBase {
  readonly type: ActionType.ADD_members_PENDING
}

//automatically dispatched by redux promise middleware
export interface ADD_members_FULFILLEDAction
  extends ActionBase, ReduxPromiseFulfilledAction<void> {
  readonly type: ActionType.ADD_members_FULFILLED
  readonly payload: void
}

//automatically dispatched by redux promise middleware
export interface ADD_members_REJECTEDAction
  extends ActionBase, ReduxPromiseRejectedAction<void> {
  readonly type: ActionType.ADD_members_REJECTED
  readonly payload: any
}


export type AllActions =
  ADD_members_PENDINGAction
  | ADD_members_FULFILLEDAction
  | ADD_members_REJECTEDAction


export function reducer(state: State = initial, action: AllActions): State {

  switch (action.type) {

    case ActionType.ADD_members_PENDING:
      return {
        ...state,
        isBusy: true
      }
    case ActionType.ADD_members_FULFILLED:
      return {
        ...state,
        isBusy: false
      }
    case ActionType.ADD_members_REJECTED:
      return {
        ...state,
        isBusy: false
      }

    default:
      notExhaustive(action)
      return state
  }
}

