/**
 * Created by janis dähne.
 */
import {notExhaustive} from "../_notExhausiveHelper";
import {initial, State} from "./singleGroupSiteReducer";
import Logger from "../../../helpers/logger";
import {
  GET_groupRoles_FULFILLEDAction, GET_groupRoles_PENDINGAction,
  GET_groupRoles_REJECTEDAction
} from "../groupRolesSite/getGroupRolesReducer";
import {ActionType} from "../groupRolesSite/groupRolesSiteActionTypes";


export type AllActions =
  GET_groupRoles_PENDINGAction
  | GET_groupRoles_FULFILLEDAction
  | GET_groupRoles_REJECTEDAction


export function reducer(state: State = initial, action: AllActions): State {

  switch (action.type) {

    case ActionType.GET_groupRoles_PENDING:
      return {
        ...state,
        isLoading: true
      }
    case ActionType.GET_groupRoles_FULFILLED:
      return {
        ...state,
        isLoading: false,
        groupRoles: action.payload
      }
    case ActionType.GET_groupRoles_REJECTED:
      return {
        ...state,
        isLoading: false,
        groupRoles: []
      }

    default:
      notExhaustive(action)
      return state
  }
}

