/**
 * Created by janis dähne.
 */
import {notExhaustive} from "../_notExhausiveHelper";
import {ReduxPromiseAction, ReduxPromiseFulfilledAction, ReduxPromiseRejectedAction} from "../index";
import {ActionBase, ActionType} from "./singleGroupSiteActionTypes";
import {initial, State} from "./singleGroupSiteReducer";
import Logger from "../../../helpers/logger";


export interface REMOVE_memberAction
  extends ActionBase, ReduxPromiseAction<void, REMOVE_member_PENDINGAction, REMOVE_member_FULFILLEDAction, REMOVE_member_REJECTEDAction> {
  readonly type: ActionType.REMOVE_member
  readonly payload: Promise<void>
}

//automatically dispatched by redux promise middleware
export interface REMOVE_member_PENDINGAction
  extends ActionBase {
  readonly type: ActionType.REMOVE_member_PENDING
}

//automatically dispatched by redux promise middleware
export interface REMOVE_member_FULFILLEDAction
  extends ActionBase, ReduxPromiseFulfilledAction<void> {
  readonly type: ActionType.REMOVE_member_FULFILLED
  readonly payload: void
}

//automatically dispatched by redux promise middleware
export interface REMOVE_member_REJECTEDAction
  extends ActionBase, ReduxPromiseRejectedAction<void> {
  readonly type: ActionType.REMOVE_member_REJECTED
  readonly payload: any
}


export type AllActions =
  REMOVE_member_PENDINGAction
  | REMOVE_member_FULFILLEDAction
  | REMOVE_member_REJECTEDAction


export function reducer(state: State = initial, action: AllActions): State {

  switch (action.type) {

    case ActionType.REMOVE_member_PENDING:
      return {
        ...state,
        isLoading: true
      }
    case ActionType.REMOVE_member_FULFILLED:
      return {
        ...state,
        isLoading: false
      }
    case ActionType.REMOVE_member_REJECTED:
      return {
        ...state,
        isLoading: false
      }

    default:
      notExhaustive(action)
      return state
  }
}

