/**
 * Created by janis dähne.
 */
import {ActionBase, ActionType} from "../tutorViewSiteActionTypes";
import {initial, State} from "../tutorViewSiteReducer";
import Logger from "../../../../helpers/logger";
import {ReduxPromiseAction, ReduxPromiseFulfilledAction, ReduxPromiseRejectedAction} from "../../index";
import {notExhaustive} from "../../_notExhausiveHelper";


export interface UPDATE_singleAssessmentAction
  extends ActionBase, ReduxPromiseAction<void, UPDATE_singleAssessment_PENDINGAction, UPDATE_singleAssessment_FULFILLEDAction, UPDATE_singleAssessment_REJECTEDAction> {
  readonly type: ActionType.UPDATE_singleAssessment
  readonly payload: Promise<void>
}

//automatically dispatched by redux promise middleware
export interface UPDATE_singleAssessment_PENDINGAction
  extends ActionBase {
  readonly type: ActionType.UPDATE_singleAssessment_PENDING
}

//automatically dispatched by redux promise middleware
export interface UPDATE_singleAssessment_FULFILLEDAction
  extends ActionBase, ReduxPromiseFulfilledAction<void> {
  readonly type: ActionType.UPDATE_singleAssessment_FULFILLED
  readonly payload: void
}

//automatically dispatched by redux promise middleware
export interface UPDATE_singleAssessment_REJECTEDAction
  extends ActionBase, ReduxPromiseRejectedAction<void> {
  readonly type: ActionType.UPDATE_singleAssessment_REJECTED
  readonly payload: any
}


export type AllActions =
  UPDATE_singleAssessment_PENDINGAction
  | UPDATE_singleAssessment_FULFILLEDAction
  | UPDATE_singleAssessment_REJECTEDAction


export function reducer(state: State = initial, action: AllActions): State {

  switch (action.type) {

    case ActionType.UPDATE_singleAssessment_PENDING:
      return {
        ...state,
        isLoading: true
      }
    case ActionType.UPDATE_singleAssessment_FULFILLED:
      return {
        ...state,
        isLoading: false
      }
    case ActionType.UPDATE_singleAssessment_REJECTED:
      return {
        ...state,
        isLoading: false
      }

    default:
      notExhaustive(action)
      return state
  }
}

