/**
 * Created by janis dähne.
 */

import {ActionBase, ActionType} from "../tutorViewSiteActionTypes";
import {notExhaustive} from "../../_notExhausiveHelper";
import {HasFileChangedMap} from "../../../../helpers/editorHelper";
import {DoEditorState, initial as initialEditorState} from "../../doExerciseSite/editorReducers/doEditorReducer";


export const initial: DoEditorState = {
  ...initialEditorState
}

//--- do editor

export interface SET_userSolutionEditor_selectedTabIdDoEditorAction extends ActionBase {
  readonly type: ActionType.SET_userSolutionEditor_selectedTabIdDoEditor
  readonly selectedTabIdDoEditor: number
}

export interface SET_userSolutionEditor_isFileExplorerDisplayedDoEditorAction extends ActionBase {
  readonly type: ActionType.SET_userSolutionEditor_isFileExplorerDisplayedDoEditor
  readonly isFileExplorerDisplayedDoEditor: boolean
}


export type AllActions =
  SET_userSolutionEditor_selectedTabIdDoEditorAction
  | SET_userSolutionEditor_isFileExplorerDisplayedDoEditorAction



export function reducer(state: DoEditorState = initial, action: AllActions): DoEditorState {

  switch (action.type) {

    case ActionType.SET_userSolutionEditor_selectedTabIdDoEditor:
      return {
        ...state,
        selectedTabIdDoEditor: action.selectedTabIdDoEditor
      }
    case ActionType.SET_userSolutionEditor_isFileExplorerDisplayedDoEditor:
      return {
        ...state,
        isFileExplorerDisplayedDoEditor: action.isFileExplorerDisplayedDoEditor
      }

    default:
      notExhaustive(action)
      return state
  }
}

