/**
 * Created by janis dähne.
 */


/**
 * fields can be -1 on error...
 */
export interface HardwareUsageStatistic {
  readonly totalRamInKb: number
  readonly freeRamInKb: number
  readonly cpuUsageInPercentage: number
}

export interface HardwareUsageStatisticFrontendExclusive extends HardwareUsageStatistic {
  /**
   * the time to display
   */
  readonly time: string
}


export interface LogicalUsageStatistic {
  readonly totalActivatedUsers: number

  readonly totalNotActivatedUsers: number
  /**
   * just an approximation
   */
  readonly totalOnlineUsers: number
  readonly totalSystemRoles: number
  readonly totalGroupRoles: number
  readonly totalExercises: number
  readonly totalCustomProjects: number
}

export interface ClientServerSettings {

  readonly testServerUrl: string
  readonly testServerStatsUrl: string
  readonly submitTestServerUrl: string
  readonly externalLoginUrl: string
  readonly runAssessmentsAsync: boolean
  readonly loginExternalFirstTimeSite: string
  readonly maxNumberOfTestsWithOneRequest: number
  readonly maxNumberOfTestsWithOneRequestSubmitTestServer: number
  readonly testServerTimeoutInMs: number
  readonly submitTestServerTimeoutInMs: number
  readonly tokenTimeoutInS: number
  readonly port: number
  readonly apiPrefix: string
  readonly isDebug: boolean
  readonly dashboardScriptPathRelativeToCurrentDir: string

}

export interface TestServerSettings {

  readonly workingDirFullPath: string
  readonly hardGlobalTimeoutInMs: number
  readonly changeDirIntervalInS: number
  readonly maxParallelTests: number
  readonly maxNumberOfTestsWithOneRequest: number
  readonly maxLinesToRead: number
  readonly maxErrLinesToRead: number
  readonly maxLinesToWrite: number

  readonly dbServer: string
  readonly dbName: string

  readonly useConfigFromDb: boolean
  readonly dbConfigServer: string
  readonly dbConfigName: string
}