/**
 * Created by janis dähne.
 */



/**
 * he systems settings and some other useful settings for the server
 */
export interface SystemSettingsFromBackend {

  /**
   * the max solutions a user can have for an solution
   * OR less or equal 0 for unlimited e.g. 0 or -1 or -100
   */
  readonly maxSolutionVersionsPerUser: number

  /**
   * the default group when a user creates a new group
   */
  readonly defaultGroupCreatorGroupRoleId: number

  /**
   * the default group for new users
   */
  readonly defaultUserGroupId: number

  /**
   * the number of tests that can be run with one request (only the first X tests will be executed ... the other will be ignored)
   */
  readonly maxNumberOfTestsWithOneRequest: number

  /**
   * the max amount of custom projects a user can create
   * IF THIS IS CHANGED AND a user has more projects not project will be deleted!!
   * OR lerr or equal 0 for unlimited
   */
  readonly maxCustomProjectsPerUser: number

}